/* interface.c generated by valac 0.56.18, the Vala compiler
 * generated from interface.vala, do not modify */

/*
 *  Copyright (c) 2009-2010 Mike Massonnet <mmassonnet@xfce.org>
 *  Copyright (c) 2009-2010 Vincent Legout <vincent@xfce.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "xfmpc.h"
#include <src/libc/mpdclient.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <xfce-revision.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	XFMPC_INTERFACE_0_PROPERTY,
	XFMPC_INTERFACE_NUM_PROPERTIES
};
static GParamSpec* xfmpc_interface_properties[XFMPC_INTERFACE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pango_attribute_destroy0(var) ((var == NULL) ? NULL : (var = (pango_attribute_destroy (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))

struct _XfmpcInterfacePrivate {
	XfmpcMpdclient* mpdclient;
	XfmpcPreferences* preferences;
	GtkButton* button_prev;
	GtkButton* button_pp;
	GtkButton* button_next;
	GtkVolumeButton* button_volume;
	XfmpcProgressBar* progress_bar;
	GtkLabel* title;
	GtkLabel* subtitle;
	gboolean progress_bar_sync;
};

static gint XfmpcInterface_private_offset;
static gpointer xfmpc_interface_parent_class = NULL;

static gboolean xfmpc_interface_cb_progress_box_motion_event (XfmpcInterface* self,
                                                       GdkEventMotion* event);
static gboolean xfmpc_interface_cb_progress_box_press_event (XfmpcInterface* self,
                                                      GdkEventButton* event);
static gboolean xfmpc_interface_cb_progress_box_release_event (XfmpcInterface* self,
                                                        GdkEventButton* event);
static void xfmpc_interface_cb_song_changed (XfmpcInterface* self);
static void xfmpc_interface_cb_pp_changed (XfmpcInterface* self,
                                    gboolean is_playing);
static void xfmpc_interface_cb_time_changed (XfmpcInterface* self,
                                      gint song_time);
static void xfmpc_interface_cb_total_time_changed (XfmpcInterface* self,
                                            gint total_time);
static void xfmpc_interface_cb_volume_changed (XfmpcInterface* self,
                                        gint volume);
static void xfmpc_interface_cb_playlist_changed (XfmpcInterface* self);
static void xfmpc_interface_cb_stopped (XfmpcInterface* self);
static void xfmpc_interface_cb_mpdclient_previous (XfmpcInterface* self);
static void xfmpc_interface_cb_mpdclient_next (XfmpcInterface* self);
static GObject * xfmpc_interface_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _xfmpc_interface_cb_mpdclient_previous_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void _xfmpc_interface_pp_clicked_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self);
static void _xfmpc_interface_cb_mpdclient_next_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void _xfmpc_interface_volume_changed_gtk_scale_button_value_changed (GtkScaleButton* _sender,
                                                                     gdouble value,
                                                                     gpointer self);
static gboolean _xfmpc_interface_cb_progress_box_motion_event_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                       GdkEventMotion* event,
                                                                                       gpointer self);
static gboolean _xfmpc_interface_cb_progress_box_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                     GdkEventButton* event,
                                                                                     gpointer self);
static gboolean _xfmpc_interface_cb_progress_box_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                         GdkEventButton* event,
                                                                                         gpointer self);
static void _xfmpc_interface_cb_song_changed_xfmpc_mpdclient_song_changed (XfmpcMpdclient* _sender,
                                                                    gpointer self);
static void _xfmpc_interface_cb_pp_changed_xfmpc_mpdclient_pp_changed (XfmpcMpdclient* _sender,
                                                                gboolean is_playing,
                                                                gpointer self);
static void _xfmpc_interface_cb_time_changed_xfmpc_mpdclient_time_changed (XfmpcMpdclient* _sender,
                                                                    gint song_time,
                                                                    gpointer self);
static void _xfmpc_interface_cb_total_time_changed_xfmpc_mpdclient_total_time_changed (XfmpcMpdclient* _sender,
                                                                                gint total_time,
                                                                                gpointer self);
static void _xfmpc_interface_cb_volume_changed_xfmpc_mpdclient_volume_changed (XfmpcMpdclient* _sender,
                                                                        gint volume,
                                                                        gpointer self);
static void _xfmpc_interface_cb_playlist_changed_xfmpc_mpdclient_playlist_changed (XfmpcMpdclient* _sender,
                                                                            gpointer self);
static void _xfmpc_interface_cb_stopped_xfmpc_mpdclient_stopped (XfmpcMpdclient* _sender,
                                                          gpointer self);
static void xfmpc_interface_finalize (GObject * obj);
static GType xfmpc_interface_get_type_once (void);

static inline gpointer
xfmpc_interface_get_instance_private (XfmpcInterface* self)
{
	return G_STRUCT_MEMBER_P (self, XfmpcInterface_private_offset);
}

void
xfmpc_interface_set_title (XfmpcInterface* self,
                           const gchar* title)
{
	GtkLabel* _tmp0_;
#line 144 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/interface.vala"
	g_return_if_fail (title != NULL);
#line 145 "../src/interface.vala"
	_tmp0_ = self->priv->title;
#line 145 "../src/interface.vala"
	gtk_label_set_text (_tmp0_, title);
#line 155 "interface.c"
}

void
xfmpc_interface_set_subtitle (XfmpcInterface* self,
                              const gchar* subtitle)
{
	GtkLabel* _tmp0_;
#line 148 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/interface.vala"
	g_return_if_fail (subtitle != NULL);
#line 149 "../src/interface.vala"
	_tmp0_ = self->priv->subtitle;
#line 149 "../src/interface.vala"
	gtk_label_set_text (_tmp0_, subtitle);
#line 171 "interface.c"
}

void
xfmpc_interface_pp_clicked (XfmpcInterface* self)
{
	XfmpcMpdclient* _tmp0_;
	XfmpcMpdclient* _tmp1_;
#line 152 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/interface.vala"
	_tmp0_ = self->priv->mpdclient;
#line 153 "../src/interface.vala"
	if (!xfmpc_mpdclient_pp (_tmp0_)) {
#line 154 "../src/interface.vala"
		return;
#line 187 "interface.c"
	}
#line 155 "../src/interface.vala"
	_tmp1_ = self->priv->mpdclient;
#line 155 "../src/interface.vala"
	xfmpc_interface_set_pp (self, xfmpc_mpdclient_is_playing (_tmp1_));
#line 193 "interface.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 159 "../src/interface.vala"
	return self ? g_object_ref (self) : NULL;
#line 201 "interface.c"
}

void
xfmpc_interface_set_pp (XfmpcInterface* self,
                        gboolean play)
{
	GtkImage* image = NULL;
	GtkButton* _tmp0_;
	GtkWidget* _tmp1_;
	GtkImage* _tmp2_;
#line 158 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/interface.vala"
	_tmp0_ = self->priv->button_pp;
#line 159 "../src/interface.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
#line 159 "../src/interface.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_image_get_type (), GtkImage));
#line 159 "../src/interface.vala"
	image = _tmp2_;
#line 161 "../src/interface.vala"
	if (play == TRUE) {
#line 224 "interface.c"
		GtkImage* _tmp3_;
#line 162 "../src/interface.vala"
		_tmp3_ = image;
#line 162 "../src/interface.vala"
		gtk_image_set_from_icon_name (_tmp3_, "media-playback-pause", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 230 "interface.c"
	} else {
		GtkImage* _tmp4_;
#line 164 "../src/interface.vala"
		_tmp4_ = image;
#line 164 "../src/interface.vala"
		gtk_image_set_from_icon_name (_tmp4_, "media-playback-start", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 237 "interface.c"
	}
#line 158 "../src/interface.vala"
	_g_object_unref0 (image);
#line 241 "interface.c"
}

static gboolean
xfmpc_interface_cb_progress_box_motion_event (XfmpcInterface* self,
                                              GdkEventMotion* event)
{
	gint time_total = 0;
	XfmpcMpdclient* _tmp0_;
	GtkAllocation allocation = {0};
	XfmpcProgressBar* _tmp1_;
	GtkAllocation _tmp2_ = {0};
	gdouble song_time = 0.0;
	GtkAllocation _tmp3_;
	gboolean result;
#line 167 "../src/interface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 167 "../src/interface.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 171 "../src/interface.vala"
	_tmp0_ = self->priv->mpdclient;
#line 171 "../src/interface.vala"
	time_total = xfmpc_mpdclient_get_total_time (_tmp0_);
#line 172 "../src/interface.vala"
	if (time_total < 0) {
#line 173 "../src/interface.vala"
		result = FALSE;
#line 173 "../src/interface.vala"
		return result;
#line 270 "interface.c"
	}
#line 176 "../src/interface.vala"
	_tmp1_ = self->priv->progress_bar;
#line 176 "../src/interface.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp1_, &_tmp2_);
#line 176 "../src/interface.vala"
	allocation = _tmp2_;
#line 177 "../src/interface.vala"
	_tmp3_ = allocation;
#line 177 "../src/interface.vala"
	song_time = event->x / _tmp3_.width;
#line 178 "../src/interface.vala"
	song_time *= (gdouble) time_total;
#line 180 "../src/interface.vala"
	if (song_time < ((gdouble) 0)) {
#line 181 "../src/interface.vala"
		song_time = (gdouble) 0;
#line 288 "interface.c"
	} else {
#line 182 "../src/interface.vala"
		if (song_time > ((gdouble) time_total)) {
#line 183 "../src/interface.vala"
			song_time = (gdouble) time_total;
#line 294 "interface.c"
		}
	}
#line 185 "../src/interface.vala"
	xfmpc_interface_set_time (self, (gint) song_time, time_total);
#line 186 "../src/interface.vala"
	result = FALSE;
#line 186 "../src/interface.vala"
	return result;
#line 303 "interface.c"
}

static gboolean
xfmpc_interface_cb_progress_box_press_event (XfmpcInterface* self,
                                             GdkEventButton* event)
{
	gboolean result;
#line 189 "../src/interface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 189 "../src/interface.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 191 "../src/interface.vala"
	self->priv->progress_bar_sync = FALSE;
#line 192 "../src/interface.vala"
	result = FALSE;
#line 192 "../src/interface.vala"
	return result;
#line 321 "interface.c"
}

static gboolean
xfmpc_interface_cb_progress_box_release_event (XfmpcInterface* self,
                                               GdkEventButton* event)
{
	gboolean _tmp0_ = FALSE;
	gint time_total = 0;
	XfmpcMpdclient* _tmp1_;
	GtkAllocation allocation = {0};
	XfmpcProgressBar* _tmp2_;
	GtkAllocation _tmp3_ = {0};
	gdouble song_time = 0.0;
	GtkAllocation _tmp4_;
	XfmpcMpdclient* _tmp5_;
	gboolean result;
#line 195 "../src/interface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 195 "../src/interface.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 196 "../src/interface.vala"
	if (event->type != GDK_BUTTON_RELEASE) {
#line 196 "../src/interface.vala"
		_tmp0_ = TRUE;
#line 346 "interface.c"
	} else {
#line 196 "../src/interface.vala"
		_tmp0_ = event->button != ((guint) 1);
#line 350 "interface.c"
	}
#line 196 "../src/interface.vala"
	if (_tmp0_) {
#line 197 "../src/interface.vala"
		result = FALSE;
#line 197 "../src/interface.vala"
		return result;
#line 358 "interface.c"
	}
#line 200 "../src/interface.vala"
	self->priv->progress_bar_sync = TRUE;
#line 202 "../src/interface.vala"
	_tmp1_ = self->priv->mpdclient;
#line 202 "../src/interface.vala"
	time_total = xfmpc_mpdclient_get_total_time (_tmp1_);
#line 203 "../src/interface.vala"
	if (time_total < 0) {
#line 204 "../src/interface.vala"
		result = FALSE;
#line 204 "../src/interface.vala"
		return result;
#line 372 "interface.c"
	}
#line 207 "../src/interface.vala"
	_tmp2_ = self->priv->progress_bar;
#line 207 "../src/interface.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp2_, &_tmp3_);
#line 207 "../src/interface.vala"
	allocation = _tmp3_;
#line 208 "../src/interface.vala"
	_tmp4_ = allocation;
#line 208 "../src/interface.vala"
	song_time = event->x / _tmp4_.width;
#line 209 "../src/interface.vala"
	song_time *= (gdouble) time_total;
#line 211 "../src/interface.vala"
	_tmp5_ = self->priv->mpdclient;
#line 211 "../src/interface.vala"
	xfmpc_mpdclient_set_song_time (_tmp5_, (guint) ((gint) song_time));
#line 213 "../src/interface.vala"
	result = TRUE;
#line 213 "../src/interface.vala"
	return result;
#line 394 "interface.c"
}

void
xfmpc_interface_volume_changed (XfmpcInterface* self,
                                gdouble value)
{
	XfmpcMpdclient* _tmp0_;
#line 216 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/interface.vala"
	_tmp0_ = self->priv->mpdclient;
#line 217 "../src/interface.vala"
	xfmpc_mpdclient_set_volume (_tmp0_, (guchar) ((gchar) value));
#line 408 "interface.c"
}

void
xfmpc_interface_set_volume (XfmpcInterface* self,
                            gint volume)
{
	GtkVolumeButton* _tmp0_;
#line 220 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/interface.vala"
	_tmp0_ = self->priv->button_volume;
#line 221 "../src/interface.vala"
	gtk_scale_button_set_value ((GtkScaleButton*) _tmp0_, (gdouble) volume);
#line 422 "interface.c"
}

void
xfmpc_interface_popup_volume (XfmpcInterface* self)
{
	GtkVolumeButton* _tmp0_;
#line 224 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/interface.vala"
	_tmp0_ = self->priv->button_volume;
#line 225 "../src/interface.vala"
	g_signal_emit_by_name (_tmp0_, "popup", NULL, NULL);
#line 435 "interface.c"
}

void
xfmpc_interface_set_time (XfmpcInterface* self,
                          gint song_time,
                          gint time_total)
{
	gint min = 0;
	gint sec = 0;
	gint min_total = 0;
	gint sec_total = 0;
	gdouble fraction = 0.0;
	GString* text = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	XfmpcProgressBar* _tmp2_;
	GString* _tmp3_;
	const gchar* _tmp4_;
	gdouble _tmp5_ = 0.0;
	XfmpcProgressBar* _tmp6_;
#line 228 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 230 "../src/interface.vala"
	fraction = 1.0;
#line 232 "../src/interface.vala"
	min = song_time / 60;
#line 233 "../src/interface.vala"
	sec = song_time % 60;
#line 235 "../src/interface.vala"
	min_total = time_total / 60;
#line 236 "../src/interface.vala"
	sec_total = time_total % 60;
#line 238 "../src/interface.vala"
	_tmp0_ = g_string_new ("");
#line 238 "../src/interface.vala"
	text = _tmp0_;
#line 239 "../src/interface.vala"
	_tmp1_ = text;
#line 239 "../src/interface.vala"
	g_string_append_printf (_tmp1_, "%d:%02d / %d:%02d", min, sec, min_total, sec_total);
#line 240 "../src/interface.vala"
	_tmp2_ = self->priv->progress_bar;
#line 240 "../src/interface.vala"
	_tmp3_ = text;
#line 240 "../src/interface.vala"
	_tmp4_ = _tmp3_->str;
#line 240 "../src/interface.vala"
	xfmpc_progress_bar_set_text (_tmp2_, _tmp4_);
#line 242 "../src/interface.vala"
	if (time_total > 0) {
#line 243 "../src/interface.vala"
		fraction = (gdouble) (((gfloat) song_time) / ((gfloat) time_total));
#line 488 "interface.c"
	}
#line 245 "../src/interface.vala"
	if (fraction <= 1.0) {
#line 245 "../src/interface.vala"
		_tmp5_ = fraction;
#line 494 "interface.c"
	} else {
#line 245 "../src/interface.vala"
		_tmp5_ = 1.0;
#line 498 "interface.c"
	}
#line 245 "../src/interface.vala"
	_tmp6_ = self->priv->progress_bar;
#line 245 "../src/interface.vala"
	xfmpc_progress_bar_set_fraction (_tmp6_, _tmp5_);
#line 228 "../src/interface.vala"
	_g_string_free0 (text);
#line 506 "interface.c"
}

void
xfmpc_interface_reset (XfmpcInterface* self)
{
#line 248 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 249 "../src/interface.vala"
	xfmpc_interface_set_pp (self, FALSE);
#line 250 "../src/interface.vala"
	xfmpc_interface_set_time (self, 0, 0);
#line 251 "../src/interface.vala"
	xfmpc_interface_set_volume (self, 0);
#line 252 "../src/interface.vala"
	xfmpc_interface_update_title (self);
#line 522 "interface.c"
}

void
xfmpc_interface_update_title (XfmpcInterface* self)
{
	XfmpcMpdclient* _tmp0_;
#line 255 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 256 "../src/interface.vala"
	_tmp0_ = self->priv->mpdclient;
#line 256 "../src/interface.vala"
	if (xfmpc_mpdclient_is_playing (_tmp0_)) {
#line 535 "interface.c"
		XfmpcMpdclient* _tmp1_;
		const gchar* _tmp2_;
		gchar* text = NULL;
		XfmpcMpdclient* _tmp3_;
		const gchar* _tmp4_;
		XfmpcMpdclient* _tmp5_;
		const gchar* _tmp6_;
		XfmpcMpdclient* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
#line 257 "../src/interface.vala"
		_tmp1_ = self->priv->mpdclient;
#line 257 "../src/interface.vala"
		_tmp2_ = xfmpc_mpdclient_get_title (_tmp1_);
#line 257 "../src/interface.vala"
		xfmpc_interface_set_title (self, _tmp2_);
#line 264 "../src/interface.vala"
		_tmp3_ = self->priv->mpdclient;
#line 264 "../src/interface.vala"
		_tmp4_ = xfmpc_mpdclient_get_artist (_tmp3_);
#line 264 "../src/interface.vala"
		_tmp5_ = self->priv->mpdclient;
#line 264 "../src/interface.vala"
		_tmp6_ = xfmpc_mpdclient_get_album (_tmp5_);
#line 264 "../src/interface.vala"
		_tmp7_ = self->priv->mpdclient;
#line 264 "../src/interface.vala"
		_tmp8_ = xfmpc_mpdclient_get_date (_tmp7_);
#line 264 "../src/interface.vala"
		_tmp9_ = g_strdup_printf (_ ("by \"%s\" from \"%s\" (%s)"), _tmp4_, _tmp6_, _tmp8_);
#line 264 "../src/interface.vala"
		text = _tmp9_;
#line 268 "../src/interface.vala"
		_tmp10_ = text;
#line 268 "../src/interface.vala"
		xfmpc_interface_set_subtitle (self, _tmp10_);
#line 256 "../src/interface.vala"
		_g_free0 (text);
#line 575 "interface.c"
	} else {
		XfmpcMpdclient* _tmp11_;
#line 270 "../src/interface.vala"
		_tmp11_ = self->priv->mpdclient;
#line 270 "../src/interface.vala"
		if (xfmpc_mpdclient_is_stopped (_tmp11_)) {
#line 271 "../src/interface.vala"
			xfmpc_interface_set_title (self, _ ("Stopped"));
#line 272 "../src/interface.vala"
			xfmpc_interface_set_subtitle (self, PACKAGE_STRING);
#line 586 "interface.c"
		} else {
			XfmpcMpdclient* _tmp12_;
#line 274 "../src/interface.vala"
			_tmp12_ = self->priv->mpdclient;
#line 274 "../src/interface.vala"
			if (!xfmpc_mpdclient_is_connected (_tmp12_)) {
#line 275 "../src/interface.vala"
				xfmpc_interface_set_title (self, _ ("Not connected"));
#line 276 "../src/interface.vala"
				xfmpc_interface_set_subtitle (self, PACKAGE_STRING);
#line 597 "interface.c"
			}
		}
	}
}

static void
xfmpc_interface_cb_song_changed (XfmpcInterface* self)
{
#line 280 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 281 "../src/interface.vala"
	xfmpc_interface_update_title (self);
#line 610 "interface.c"
}

static void
xfmpc_interface_cb_pp_changed (XfmpcInterface* self,
                               gboolean is_playing)
{
#line 284 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 285 "../src/interface.vala"
	xfmpc_interface_set_pp (self, is_playing);
#line 286 "../src/interface.vala"
	xfmpc_interface_cb_song_changed (self);
#line 623 "interface.c"
}

static void
xfmpc_interface_cb_time_changed (XfmpcInterface* self,
                                 gint song_time)
{
	XfmpcMpdclient* _tmp0_;
#line 289 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/interface.vala"
	if (self->priv->progress_bar_sync == FALSE) {
#line 291 "../src/interface.vala"
		return;
#line 637 "interface.c"
	}
#line 292 "../src/interface.vala"
	_tmp0_ = self->priv->mpdclient;
#line 292 "../src/interface.vala"
	xfmpc_interface_set_time (self, song_time, xfmpc_mpdclient_get_total_time (_tmp0_));
#line 643 "interface.c"
}

static void
xfmpc_interface_cb_total_time_changed (XfmpcInterface* self,
                                       gint total_time)
{
	XfmpcMpdclient* _tmp0_;
#line 295 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 296 "../src/interface.vala"
	if (self->priv->progress_bar_sync == FALSE) {
#line 297 "../src/interface.vala"
		return;
#line 657 "interface.c"
	}
#line 298 "../src/interface.vala"
	_tmp0_ = self->priv->mpdclient;
#line 298 "../src/interface.vala"
	xfmpc_interface_set_time (self, xfmpc_mpdclient_get_time (_tmp0_), total_time);
#line 663 "interface.c"
}

static void
xfmpc_interface_cb_volume_changed (XfmpcInterface* self,
                                   gint volume)
{
#line 301 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 302 "../src/interface.vala"
	xfmpc_interface_set_volume (self, volume);
#line 674 "interface.c"
}

static void
xfmpc_interface_cb_playlist_changed (XfmpcInterface* self)
{
#line 305 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 306 "../src/interface.vala"
	xfmpc_interface_update_title (self);
#line 684 "interface.c"
}

static void
xfmpc_interface_cb_stopped (XfmpcInterface* self)
{
#line 309 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/interface.vala"
	xfmpc_interface_set_pp (self, FALSE);
#line 311 "../src/interface.vala"
	xfmpc_interface_update_title (self);
#line 696 "interface.c"
}

static void
xfmpc_interface_cb_mpdclient_previous (XfmpcInterface* self)
{
	XfmpcMpdclient* _tmp0_;
#line 314 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 315 "../src/interface.vala"
	_tmp0_ = self->priv->mpdclient;
#line 315 "../src/interface.vala"
	xfmpc_mpdclient_previous (_tmp0_);
#line 709 "interface.c"
}

static void
xfmpc_interface_cb_mpdclient_next (XfmpcInterface* self)
{
	XfmpcMpdclient* _tmp0_;
#line 318 "../src/interface.vala"
	g_return_if_fail (self != NULL);
#line 319 "../src/interface.vala"
	_tmp0_ = self->priv->mpdclient;
#line 319 "../src/interface.vala"
	xfmpc_mpdclient_next (_tmp0_);
#line 722 "interface.c"
}

XfmpcInterface*
xfmpc_interface_construct (GType object_type)
{
	XfmpcInterface * self = NULL;
#line 24 "../src/interface.vala"
	self = (XfmpcInterface*) g_object_new (object_type, NULL);
#line 24 "../src/interface.vala"
	return self;
#line 733 "interface.c"
}

XfmpcInterface*
xfmpc_interface_new (void)
{
#line 24 "../src/interface.vala"
	return xfmpc_interface_construct (XFMPC_TYPE_INTERFACE);
#line 741 "interface.c"
}

static void
_xfmpc_interface_cb_mpdclient_previous_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 127 "../src/interface.vala"
	xfmpc_interface_cb_mpdclient_previous ((XfmpcInterface*) self);
#line 750 "interface.c"
}

static void
_xfmpc_interface_pp_clicked_gtk_button_clicked (GtkButton* _sender,
                                                gpointer self)
{
#line 128 "../src/interface.vala"
	xfmpc_interface_pp_clicked ((XfmpcInterface*) self);
#line 759 "interface.c"
}

static void
_xfmpc_interface_cb_mpdclient_next_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
#line 129 "../src/interface.vala"
	xfmpc_interface_cb_mpdclient_next ((XfmpcInterface*) self);
#line 768 "interface.c"
}

static void
_xfmpc_interface_volume_changed_gtk_scale_button_value_changed (GtkScaleButton* _sender,
                                                                gdouble value,
                                                                gpointer self)
{
#line 130 "../src/interface.vala"
	xfmpc_interface_volume_changed ((XfmpcInterface*) self, value);
#line 778 "interface.c"
}

static gboolean
_xfmpc_interface_cb_progress_box_motion_event_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                              GdkEventMotion* event,
                                                                              gpointer self)
{
	gboolean result;
	result = xfmpc_interface_cb_progress_box_motion_event ((XfmpcInterface*) self, event);
#line 131 "../src/interface.vala"
	return result;
#line 790 "interface.c"
}

static gboolean
_xfmpc_interface_cb_progress_box_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                            GdkEventButton* event,
                                                                            gpointer self)
{
	gboolean result;
	result = xfmpc_interface_cb_progress_box_press_event ((XfmpcInterface*) self, event);
#line 132 "../src/interface.vala"
	return result;
#line 802 "interface.c"
}

static gboolean
_xfmpc_interface_cb_progress_box_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                GdkEventButton* event,
                                                                                gpointer self)
{
	gboolean result;
	result = xfmpc_interface_cb_progress_box_release_event ((XfmpcInterface*) self, event);
#line 133 "../src/interface.vala"
	return result;
#line 814 "interface.c"
}

static void
_xfmpc_interface_cb_song_changed_xfmpc_mpdclient_song_changed (XfmpcMpdclient* _sender,
                                                               gpointer self)
{
#line 135 "../src/interface.vala"
	xfmpc_interface_cb_song_changed ((XfmpcInterface*) self);
#line 823 "interface.c"
}

static void
_xfmpc_interface_cb_pp_changed_xfmpc_mpdclient_pp_changed (XfmpcMpdclient* _sender,
                                                           gboolean is_playing,
                                                           gpointer self)
{
#line 136 "../src/interface.vala"
	xfmpc_interface_cb_pp_changed ((XfmpcInterface*) self, is_playing);
#line 833 "interface.c"
}

static void
_xfmpc_interface_cb_time_changed_xfmpc_mpdclient_time_changed (XfmpcMpdclient* _sender,
                                                               gint song_time,
                                                               gpointer self)
{
#line 137 "../src/interface.vala"
	xfmpc_interface_cb_time_changed ((XfmpcInterface*) self, song_time);
#line 843 "interface.c"
}

static void
_xfmpc_interface_cb_total_time_changed_xfmpc_mpdclient_total_time_changed (XfmpcMpdclient* _sender,
                                                                           gint total_time,
                                                                           gpointer self)
{
#line 138 "../src/interface.vala"
	xfmpc_interface_cb_total_time_changed ((XfmpcInterface*) self, total_time);
#line 853 "interface.c"
}

static void
_xfmpc_interface_cb_volume_changed_xfmpc_mpdclient_volume_changed (XfmpcMpdclient* _sender,
                                                                   gint volume,
                                                                   gpointer self)
{
#line 139 "../src/interface.vala"
	xfmpc_interface_cb_volume_changed ((XfmpcInterface*) self, volume);
#line 863 "interface.c"
}

static void
_xfmpc_interface_cb_playlist_changed_xfmpc_mpdclient_playlist_changed (XfmpcMpdclient* _sender,
                                                                       gpointer self)
{
#line 140 "../src/interface.vala"
	xfmpc_interface_cb_playlist_changed ((XfmpcInterface*) self);
#line 872 "interface.c"
}

static void
_xfmpc_interface_cb_stopped_xfmpc_mpdclient_stopped (XfmpcMpdclient* _sender,
                                                     gpointer self)
{
#line 141 "../src/interface.vala"
	xfmpc_interface_cb_stopped ((XfmpcInterface*) self);
#line 881 "interface.c"
}

static GObject *
xfmpc_interface_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	XfmpcInterface * self;
	XfmpcMpdclient* _tmp0_;
	XfmpcPreferences* _tmp1_;
	GtkImage* image = NULL;
	GtkImage* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkImage* _tmp6_;
	GtkButton* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkImage* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkImage* _tmp13_;
	GtkButton* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkImage* _tmp16_;
	GtkButton* _tmp17_;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	GtkImage* _tmp20_;
	GtkButton* _tmp21_;
	GtkStyleContext* _tmp22_;
	GtkVolumeButton* _tmp23_;
	GtkVolumeButton* _tmp24_;
	GtkVolumeButton* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkAdjustment* adjustment = NULL;
	GtkVolumeButton* _tmp27_;
	GtkAdjustment* _tmp28_;
	GtkAdjustment* _tmp29_;
	GtkAdjustment* _tmp30_;
	GtkAdjustment* _tmp31_;
	gdouble _tmp32_;
	gdouble _tmp33_;
	GtkAdjustment* _tmp34_;
	GtkAdjustment* _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	GtkAdjustment* _tmp38_;
	GtkAdjustment* _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	GtkEventBox* progress_box = NULL;
	GtkEventBox* _tmp42_;
	XfmpcProgressBar* _tmp43_;
	XfmpcProgressBar* _tmp44_;
	XfmpcProgressBar* _tmp45_;
	GtkEventBox* _tmp46_;
	XfmpcProgressBar* _tmp47_;
	GtkEventBox* _tmp48_;
	PangoAttrList* attrs = NULL;
	PangoAttrList* _tmp49_;
	PangoAttribute* attr = NULL;
	PangoAttribute* _tmp50_;
	PangoAttribute* _tmp51_;
	PangoAttribute* _tmp52_;
	PangoAttrList* _tmp53_;
	PangoAttribute* _tmp54_;
	PangoAttribute* _tmp55_;
	PangoAttribute* _tmp56_;
	PangoAttribute* _tmp57_;
	PangoAttribute* _tmp58_;
	PangoAttrList* _tmp59_;
	PangoAttribute* _tmp60_;
	PangoAttribute* _tmp61_;
	GtkLabel* _tmp62_;
	GtkLabel* _tmp63_;
	PangoAttrList* _tmp64_;
	GtkLabel* _tmp65_;
	GtkLabel* _tmp66_;
	GtkLabel* _tmp67_;
	GtkLabel* _tmp68_;
	PangoAttrList* _tmp69_;
	PangoAttribute* _tmp70_;
	PangoAttribute* _tmp71_;
	PangoAttribute* _tmp72_;
	PangoAttrList* _tmp73_;
	PangoAttribute* _tmp74_;
	PangoAttribute* _tmp75_;
	GtkLabel* _tmp76_;
	GtkLabel* _tmp77_;
	PangoAttrList* _tmp78_;
	GtkLabel* _tmp79_;
	GtkLabel* _tmp80_;
	GtkLabel* _tmp81_;
	GtkLabel* _tmp82_;
	GtkBox* box = NULL;
	GtkBox* _tmp83_;
	GtkBox* _tmp84_;
	GtkBox* _tmp85_;
	GtkButton* _tmp86_;
	GtkBox* _tmp87_;
	GtkButton* _tmp88_;
	GtkBox* _tmp89_;
	GtkButton* _tmp90_;
	GtkBox* _tmp91_;
	GtkEventBox* _tmp92_;
	GtkBox* _tmp93_;
	GtkVolumeButton* _tmp94_;
	GtkBox* vbox = NULL;
	GtkBox* _tmp95_;
	GtkBox* _tmp96_;
	GtkBox* _tmp97_;
	GtkLabel* _tmp98_;
	GtkBox* _tmp99_;
	GtkLabel* _tmp100_;
	GtkButton* _tmp101_;
	GtkButton* _tmp102_;
	GtkButton* _tmp103_;
	GtkVolumeButton* _tmp104_;
	GtkEventBox* _tmp105_;
	GtkEventBox* _tmp106_;
	GtkEventBox* _tmp107_;
	XfmpcMpdclient* _tmp108_;
	XfmpcMpdclient* _tmp109_;
	XfmpcMpdclient* _tmp110_;
	XfmpcMpdclient* _tmp111_;
	XfmpcMpdclient* _tmp112_;
	XfmpcMpdclient* _tmp113_;
	XfmpcMpdclient* _tmp114_;
#line 39 "../src/interface.vala"
	parent_class = G_OBJECT_CLASS (xfmpc_interface_parent_class);
#line 39 "../src/interface.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../src/interface.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XFMPC_TYPE_INTERFACE, XfmpcInterface);
#line 40 "../src/interface.vala"
	_tmp0_ = xfmpc_mpdclient_get_default ();
#line 40 "../src/interface.vala"
	self->priv->mpdclient = _tmp0_;
#line 41 "../src/interface.vala"
	_tmp1_ = xfmpc_preferences_get_default ();
#line 41 "../src/interface.vala"
	self->priv->preferences = _tmp1_;
#line 43 "../src/interface.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 44 "../src/interface.vala"
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 4);
#line 46 "../src/interface.vala"
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("media-skip-backward", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 46 "../src/interface.vala"
	g_object_ref_sink (_tmp2_);
#line 46 "../src/interface.vala"
	image = _tmp2_;
#line 47 "../src/interface.vala"
	_tmp3_ = (GtkButton*) gtk_button_new ();
#line 47 "../src/interface.vala"
	g_object_ref_sink (_tmp3_);
#line 47 "../src/interface.vala"
	_g_object_unref0 (self->priv->button_prev);
#line 47 "../src/interface.vala"
	self->priv->button_prev = _tmp3_;
#line 48 "../src/interface.vala"
	_tmp4_ = self->priv->button_prev;
#line 48 "../src/interface.vala"
	gtk_button_set_relief (_tmp4_, GTK_RELIEF_NONE);
#line 49 "../src/interface.vala"
	_tmp5_ = self->priv->button_prev;
#line 49 "../src/interface.vala"
	_tmp6_ = image;
#line 49 "../src/interface.vala"
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 50 "../src/interface.vala"
	_tmp7_ = self->priv->button_prev;
#line 50 "../src/interface.vala"
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
#line 50 "../src/interface.vala"
	gtk_style_context_add_class (_tmp8_, "primary-button");
#line 52 "../src/interface.vala"
	_tmp9_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-start", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 52 "../src/interface.vala"
	g_object_ref_sink (_tmp9_);
#line 52 "../src/interface.vala"
	_g_object_unref0 (image);
#line 52 "../src/interface.vala"
	image = _tmp9_;
#line 53 "../src/interface.vala"
	_tmp10_ = (GtkButton*) gtk_button_new ();
#line 53 "../src/interface.vala"
	g_object_ref_sink (_tmp10_);
#line 53 "../src/interface.vala"
	_g_object_unref0 (self->priv->button_pp);
#line 53 "../src/interface.vala"
	self->priv->button_pp = _tmp10_;
#line 54 "../src/interface.vala"
	_tmp11_ = self->priv->button_pp;
#line 54 "../src/interface.vala"
	gtk_button_set_relief (_tmp11_, GTK_RELIEF_NONE);
#line 55 "../src/interface.vala"
	_tmp12_ = self->priv->button_pp;
#line 55 "../src/interface.vala"
	_tmp13_ = image;
#line 55 "../src/interface.vala"
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 56 "../src/interface.vala"
	_tmp14_ = self->priv->button_pp;
#line 56 "../src/interface.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 56 "../src/interface.vala"
	gtk_style_context_add_class (_tmp15_, "primary-button");
#line 58 "../src/interface.vala"
	_tmp16_ = (GtkImage*) gtk_image_new_from_icon_name ("media-skip-forward", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 58 "../src/interface.vala"
	g_object_ref_sink (_tmp16_);
#line 58 "../src/interface.vala"
	_g_object_unref0 (image);
#line 58 "../src/interface.vala"
	image = _tmp16_;
#line 59 "../src/interface.vala"
	_tmp17_ = (GtkButton*) gtk_button_new ();
#line 59 "../src/interface.vala"
	g_object_ref_sink (_tmp17_);
#line 59 "../src/interface.vala"
	_g_object_unref0 (self->priv->button_next);
#line 59 "../src/interface.vala"
	self->priv->button_next = _tmp17_;
#line 60 "../src/interface.vala"
	_tmp18_ = self->priv->button_next;
#line 60 "../src/interface.vala"
	gtk_button_set_relief (_tmp18_, GTK_RELIEF_NONE);
#line 61 "../src/interface.vala"
	_tmp19_ = self->priv->button_next;
#line 61 "../src/interface.vala"
	_tmp20_ = image;
#line 61 "../src/interface.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 62 "../src/interface.vala"
	_tmp21_ = self->priv->button_next;
#line 62 "../src/interface.vala"
	_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) _tmp21_);
#line 62 "../src/interface.vala"
	gtk_style_context_add_class (_tmp22_, "primary-button");
#line 64 "../src/interface.vala"
	_tmp23_ = (GtkVolumeButton*) gtk_volume_button_new ();
#line 64 "../src/interface.vala"
	g_object_ref_sink (_tmp23_);
#line 64 "../src/interface.vala"
	_g_object_unref0 (self->priv->button_volume);
#line 64 "../src/interface.vala"
	self->priv->button_volume = _tmp23_;
#line 65 "../src/interface.vala"
	_tmp24_ = self->priv->button_volume;
#line 65 "../src/interface.vala"
	gtk_button_set_relief ((GtkButton*) _tmp24_, GTK_RELIEF_NONE);
#line 66 "../src/interface.vala"
	_tmp25_ = self->priv->button_volume;
#line 66 "../src/interface.vala"
	_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) _tmp25_);
#line 66 "../src/interface.vala"
	gtk_style_context_add_class (_tmp26_, "primary-button");
#line 67 "../src/interface.vala"
	_tmp27_ = self->priv->button_volume;
#line 67 "../src/interface.vala"
	_tmp28_ = gtk_scale_button_get_adjustment ((GtkScaleButton*) _tmp27_);
#line 67 "../src/interface.vala"
	_tmp29_ = _g_object_ref0 (_tmp28_);
#line 67 "../src/interface.vala"
	adjustment = _tmp29_;
#line 68 "../src/interface.vala"
	_tmp30_ = adjustment;
#line 68 "../src/interface.vala"
	_tmp31_ = adjustment;
#line 68 "../src/interface.vala"
	_tmp32_ = gtk_adjustment_get_upper (_tmp31_);
#line 68 "../src/interface.vala"
	_tmp33_ = _tmp32_;
#line 68 "../src/interface.vala"
	gtk_adjustment_set_upper (_tmp31_, _tmp33_ * 100);
#line 69 "../src/interface.vala"
	_tmp34_ = adjustment;
#line 69 "../src/interface.vala"
	_tmp35_ = adjustment;
#line 69 "../src/interface.vala"
	_tmp36_ = gtk_adjustment_get_step_increment (_tmp35_);
#line 69 "../src/interface.vala"
	_tmp37_ = _tmp36_;
#line 69 "../src/interface.vala"
	gtk_adjustment_set_step_increment (_tmp35_, _tmp37_ * 100);
#line 70 "../src/interface.vala"
	_tmp38_ = adjustment;
#line 70 "../src/interface.vala"
	_tmp39_ = adjustment;
#line 70 "../src/interface.vala"
	_tmp40_ = gtk_adjustment_get_page_increment (_tmp39_);
#line 70 "../src/interface.vala"
	_tmp41_ = _tmp40_;
#line 70 "../src/interface.vala"
	gtk_adjustment_set_page_increment (_tmp39_, _tmp41_ * 100);
#line 72 "../src/interface.vala"
	_tmp42_ = (GtkEventBox*) gtk_event_box_new ();
#line 72 "../src/interface.vala"
	g_object_ref_sink (_tmp42_);
#line 72 "../src/interface.vala"
	progress_box = _tmp42_;
#line 73 "../src/interface.vala"
	_tmp43_ = xfmpc_progress_bar_new ();
#line 73 "../src/interface.vala"
	g_object_ref_sink (_tmp43_);
#line 73 "../src/interface.vala"
	_g_object_unref0 (self->priv->progress_bar);
#line 73 "../src/interface.vala"
	self->priv->progress_bar = _tmp43_;
#line 74 "../src/interface.vala"
	_tmp44_ = self->priv->progress_bar;
#line 74 "../src/interface.vala"
	xfmpc_progress_bar_set_text (_tmp44_, "0:00 / 0:00");
#line 75 "../src/interface.vala"
	_tmp45_ = self->priv->progress_bar;
#line 75 "../src/interface.vala"
	xfmpc_progress_bar_set_fraction (_tmp45_, 1.0);
#line 76 "../src/interface.vala"
	_tmp46_ = progress_box;
#line 76 "../src/interface.vala"
	_tmp47_ = self->priv->progress_bar;
#line 76 "../src/interface.vala"
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
#line 77 "../src/interface.vala"
	_tmp48_ = progress_box;
#line 77 "../src/interface.vala"
	gtk_event_box_set_above_child (_tmp48_, TRUE);
#line 80 "../src/interface.vala"
	_tmp49_ = pango_attr_list_new ();
#line 80 "../src/interface.vala"
	attrs = _tmp49_;
#line 81 "../src/interface.vala"
	_tmp50_ = pango_attr_weight_new (PANGO_WEIGHT_BOLD);
#line 81 "../src/interface.vala"
	attr = _tmp50_;
#line 82 "../src/interface.vala"
	_tmp51_ = attr;
#line 82 "../src/interface.vala"
	_tmp51_->start_index = (guint) 0;
#line 83 "../src/interface.vala"
	_tmp52_ = attr;
#line 83 "../src/interface.vala"
	_tmp52_->end_index = (guint) -1;
#line 84 "../src/interface.vala"
	_tmp53_ = attrs;
#line 84 "../src/interface.vala"
	_tmp54_ = attr;
#line 84 "../src/interface.vala"
	_tmp55_ = pango_attribute_copy (_tmp54_);
#line 84 "../src/interface.vala"
	pango_attr_list_insert (_tmp53_, _tmp55_);
#line 86 "../src/interface.vala"
	_tmp56_ = pango_attr_scale_new ((gdouble) PANGO_SCALE_X_LARGE);
#line 86 "../src/interface.vala"
	_pango_attribute_destroy0 (attr);
#line 86 "../src/interface.vala"
	attr = _tmp56_;
#line 87 "../src/interface.vala"
	_tmp57_ = attr;
#line 87 "../src/interface.vala"
	_tmp57_->start_index = (guint) 0;
#line 88 "../src/interface.vala"
	_tmp58_ = attr;
#line 88 "../src/interface.vala"
	_tmp58_->end_index = (guint) -1;
#line 89 "../src/interface.vala"
	_tmp59_ = attrs;
#line 89 "../src/interface.vala"
	_tmp60_ = attr;
#line 89 "../src/interface.vala"
	_tmp61_ = pango_attribute_copy (_tmp60_);
#line 89 "../src/interface.vala"
	pango_attr_list_insert (_tmp59_, _tmp61_);
#line 91 "../src/interface.vala"
	_tmp62_ = (GtkLabel*) gtk_label_new (_ ("Not connected"));
#line 91 "../src/interface.vala"
	g_object_ref_sink (_tmp62_);
#line 91 "../src/interface.vala"
	_g_object_unref0 (self->priv->title);
#line 91 "../src/interface.vala"
	self->priv->title = _tmp62_;
#line 92 "../src/interface.vala"
	_tmp63_ = self->priv->title;
#line 92 "../src/interface.vala"
	_tmp64_ = attrs;
#line 92 "../src/interface.vala"
	gtk_label_set_attributes (_tmp63_, _tmp64_);
#line 93 "../src/interface.vala"
	_tmp65_ = self->priv->title;
#line 93 "../src/interface.vala"
	gtk_label_set_selectable (_tmp65_, TRUE);
#line 94 "../src/interface.vala"
	_tmp66_ = self->priv->title;
#line 94 "../src/interface.vala"
	gtk_label_set_ellipsize (_tmp66_, PANGO_ELLIPSIZE_END);
#line 95 "../src/interface.vala"
	_tmp67_ = self->priv->title;
#line 95 "../src/interface.vala"
	gtk_label_set_xalign (_tmp67_, 0.0f);
#line 96 "../src/interface.vala"
	_tmp68_ = self->priv->title;
#line 96 "../src/interface.vala"
	gtk_label_set_yalign (_tmp68_, 0.5f);
#line 99 "../src/interface.vala"
	_tmp69_ = pango_attr_list_new ();
#line 99 "../src/interface.vala"
	_pango_attr_list_unref0 (attrs);
#line 99 "../src/interface.vala"
	attrs = _tmp69_;
#line 100 "../src/interface.vala"
	_tmp70_ = pango_attr_scale_new ((gdouble) PANGO_SCALE_SMALL);
#line 100 "../src/interface.vala"
	_pango_attribute_destroy0 (attr);
#line 100 "../src/interface.vala"
	attr = _tmp70_;
#line 101 "../src/interface.vala"
	_tmp71_ = attr;
#line 101 "../src/interface.vala"
	_tmp71_->start_index = (guint) 0;
#line 102 "../src/interface.vala"
	_tmp72_ = attr;
#line 102 "../src/interface.vala"
	_tmp72_->end_index = (guint) -1;
#line 103 "../src/interface.vala"
	_tmp73_ = attrs;
#line 103 "../src/interface.vala"
	_tmp74_ = attr;
#line 103 "../src/interface.vala"
	_tmp75_ = pango_attribute_copy (_tmp74_);
#line 103 "../src/interface.vala"
	pango_attr_list_insert (_tmp73_, _tmp75_);
#line 105 "../src/interface.vala"
	_tmp76_ = (GtkLabel*) gtk_label_new (PACKAGE_STRING);
#line 105 "../src/interface.vala"
	g_object_ref_sink (_tmp76_);
#line 105 "../src/interface.vala"
	_g_object_unref0 (self->priv->subtitle);
#line 105 "../src/interface.vala"
	self->priv->subtitle = _tmp76_;
#line 106 "../src/interface.vala"
	_tmp77_ = self->priv->subtitle;
#line 106 "../src/interface.vala"
	_tmp78_ = attrs;
#line 106 "../src/interface.vala"
	gtk_label_set_attributes (_tmp77_, _tmp78_);
#line 107 "../src/interface.vala"
	_tmp79_ = self->priv->subtitle;
#line 107 "../src/interface.vala"
	gtk_label_set_selectable (_tmp79_, TRUE);
#line 108 "../src/interface.vala"
	_tmp80_ = self->priv->subtitle;
#line 108 "../src/interface.vala"
	gtk_label_set_ellipsize (_tmp80_, PANGO_ELLIPSIZE_END);
#line 109 "../src/interface.vala"
	_tmp81_ = self->priv->subtitle;
#line 109 "../src/interface.vala"
	gtk_label_set_xalign (_tmp81_, 0.0f);
#line 110 "../src/interface.vala"
	_tmp82_ = self->priv->subtitle;
#line 110 "../src/interface.vala"
	gtk_label_set_yalign (_tmp82_, 0.5f);
#line 113 "../src/interface.vala"
	_tmp83_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 113 "../src/interface.vala"
	g_object_ref_sink (_tmp83_);
#line 113 "../src/interface.vala"
	box = _tmp83_;
#line 114 "../src/interface.vala"
	_tmp84_ = box;
#line 114 "../src/interface.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp84_, FALSE, FALSE, (guint) 0);
#line 115 "../src/interface.vala"
	_tmp85_ = box;
#line 115 "../src/interface.vala"
	_tmp86_ = self->priv->button_prev;
#line 115 "../src/interface.vala"
	gtk_box_pack_start (_tmp85_, (GtkWidget*) _tmp86_, FALSE, FALSE, (guint) 0);
#line 116 "../src/interface.vala"
	_tmp87_ = box;
#line 116 "../src/interface.vala"
	_tmp88_ = self->priv->button_pp;
#line 116 "../src/interface.vala"
	gtk_box_pack_start (_tmp87_, (GtkWidget*) _tmp88_, FALSE, FALSE, (guint) 0);
#line 117 "../src/interface.vala"
	_tmp89_ = box;
#line 117 "../src/interface.vala"
	_tmp90_ = self->priv->button_next;
#line 117 "../src/interface.vala"
	gtk_box_pack_start (_tmp89_, (GtkWidget*) _tmp90_, FALSE, FALSE, (guint) 0);
#line 118 "../src/interface.vala"
	_tmp91_ = box;
#line 118 "../src/interface.vala"
	_tmp92_ = progress_box;
#line 118 "../src/interface.vala"
	gtk_box_pack_start (_tmp91_, (GtkWidget*) _tmp92_, TRUE, TRUE, (guint) 4);
#line 119 "../src/interface.vala"
	_tmp93_ = box;
#line 119 "../src/interface.vala"
	_tmp94_ = self->priv->button_volume;
#line 119 "../src/interface.vala"
	gtk_box_pack_start (_tmp93_, (GtkWidget*) _tmp94_, FALSE, FALSE, (guint) 0);
#line 121 "../src/interface.vala"
	_tmp95_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 121 "../src/interface.vala"
	g_object_ref_sink (_tmp95_);
#line 121 "../src/interface.vala"
	vbox = _tmp95_;
#line 122 "../src/interface.vala"
	_tmp96_ = vbox;
#line 122 "../src/interface.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp96_, FALSE, TRUE, (guint) 0);
#line 123 "../src/interface.vala"
	_tmp97_ = vbox;
#line 123 "../src/interface.vala"
	_tmp98_ = self->priv->title;
#line 123 "../src/interface.vala"
	gtk_container_add ((GtkContainer*) _tmp97_, (GtkWidget*) _tmp98_);
#line 124 "../src/interface.vala"
	_tmp99_ = vbox;
#line 124 "../src/interface.vala"
	_tmp100_ = self->priv->subtitle;
#line 124 "../src/interface.vala"
	gtk_container_add ((GtkContainer*) _tmp99_, (GtkWidget*) _tmp100_);
#line 127 "../src/interface.vala"
	_tmp101_ = self->priv->button_prev;
#line 127 "../src/interface.vala"
	g_signal_connect_object (_tmp101_, "clicked", (GCallback) _xfmpc_interface_cb_mpdclient_previous_gtk_button_clicked, self, 0);
#line 128 "../src/interface.vala"
	_tmp102_ = self->priv->button_pp;
#line 128 "../src/interface.vala"
	g_signal_connect_object (_tmp102_, "clicked", (GCallback) _xfmpc_interface_pp_clicked_gtk_button_clicked, self, 0);
#line 129 "../src/interface.vala"
	_tmp103_ = self->priv->button_next;
#line 129 "../src/interface.vala"
	g_signal_connect_object (_tmp103_, "clicked", (GCallback) _xfmpc_interface_cb_mpdclient_next_gtk_button_clicked, self, 0);
#line 130 "../src/interface.vala"
	_tmp104_ = self->priv->button_volume;
#line 130 "../src/interface.vala"
	g_signal_connect_object ((GtkScaleButton*) _tmp104_, "value-changed", (GCallback) _xfmpc_interface_volume_changed_gtk_scale_button_value_changed, self, 0);
#line 131 "../src/interface.vala"
	_tmp105_ = progress_box;
#line 131 "../src/interface.vala"
	g_signal_connect_object ((GtkWidget*) _tmp105_, "motion-notify-event", (GCallback) _xfmpc_interface_cb_progress_box_motion_event_gtk_widget_motion_notify_event, self, 0);
#line 132 "../src/interface.vala"
	_tmp106_ = progress_box;
#line 132 "../src/interface.vala"
	g_signal_connect_object ((GtkWidget*) _tmp106_, "button-press-event", (GCallback) _xfmpc_interface_cb_progress_box_press_event_gtk_widget_button_press_event, self, 0);
#line 133 "../src/interface.vala"
	_tmp107_ = progress_box;
#line 133 "../src/interface.vala"
	g_signal_connect_object ((GtkWidget*) _tmp107_, "button-release-event", (GCallback) _xfmpc_interface_cb_progress_box_release_event_gtk_widget_button_release_event, self, 0);
#line 135 "../src/interface.vala"
	_tmp108_ = self->priv->mpdclient;
#line 135 "../src/interface.vala"
	g_signal_connect_object (_tmp108_, "song-changed", (GCallback) _xfmpc_interface_cb_song_changed_xfmpc_mpdclient_song_changed, self, 0);
#line 136 "../src/interface.vala"
	_tmp109_ = self->priv->mpdclient;
#line 136 "../src/interface.vala"
	g_signal_connect_object (_tmp109_, "pp-changed", (GCallback) _xfmpc_interface_cb_pp_changed_xfmpc_mpdclient_pp_changed, self, 0);
#line 137 "../src/interface.vala"
	_tmp110_ = self->priv->mpdclient;
#line 137 "../src/interface.vala"
	g_signal_connect_object (_tmp110_, "time-changed", (GCallback) _xfmpc_interface_cb_time_changed_xfmpc_mpdclient_time_changed, self, 0);
#line 138 "../src/interface.vala"
	_tmp111_ = self->priv->mpdclient;
#line 138 "../src/interface.vala"
	g_signal_connect_object (_tmp111_, "total-time-changed", (GCallback) _xfmpc_interface_cb_total_time_changed_xfmpc_mpdclient_total_time_changed, self, 0);
#line 139 "../src/interface.vala"
	_tmp112_ = self->priv->mpdclient;
#line 139 "../src/interface.vala"
	g_signal_connect_object (_tmp112_, "volume-changed", (GCallback) _xfmpc_interface_cb_volume_changed_xfmpc_mpdclient_volume_changed, self, 0);
#line 140 "../src/interface.vala"
	_tmp113_ = self->priv->mpdclient;
#line 140 "../src/interface.vala"
	g_signal_connect_object (_tmp113_, "playlist-changed", (GCallback) _xfmpc_interface_cb_playlist_changed_xfmpc_mpdclient_playlist_changed, self, 0);
#line 141 "../src/interface.vala"
	_tmp114_ = self->priv->mpdclient;
#line 141 "../src/interface.vala"
	g_signal_connect_object (_tmp114_, "stopped", (GCallback) _xfmpc_interface_cb_stopped_xfmpc_mpdclient_stopped, self, 0);
#line 39 "../src/interface.vala"
	_g_object_unref0 (vbox);
#line 39 "../src/interface.vala"
	_g_object_unref0 (box);
#line 39 "../src/interface.vala"
	_pango_attribute_destroy0 (attr);
#line 39 "../src/interface.vala"
	_pango_attr_list_unref0 (attrs);
#line 39 "../src/interface.vala"
	_g_object_unref0 (progress_box);
#line 39 "../src/interface.vala"
	_g_object_unref0 (adjustment);
#line 39 "../src/interface.vala"
	_g_object_unref0 (image);
#line 39 "../src/interface.vala"
	return obj;
#line 1482 "interface.c"
}

static void
xfmpc_interface_class_init (XfmpcInterfaceClass * klass,
                            gpointer klass_data)
{
#line 24 "../src/interface.vala"
	xfmpc_interface_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/interface.vala"
	g_type_class_adjust_private_offset (klass, &XfmpcInterface_private_offset);
#line 24 "../src/interface.vala"
	G_OBJECT_CLASS (klass)->constructor = xfmpc_interface_constructor;
#line 24 "../src/interface.vala"
	G_OBJECT_CLASS (klass)->finalize = xfmpc_interface_finalize;
#line 1497 "interface.c"
}

static void
xfmpc_interface_instance_init (XfmpcInterface * self,
                               gpointer klass)
{
#line 24 "../src/interface.vala"
	self->priv = xfmpc_interface_get_instance_private (self);
#line 37 "../src/interface.vala"
	self->priv->progress_bar_sync = TRUE;
#line 1508 "interface.c"
}

static void
xfmpc_interface_finalize (GObject * obj)
{
	XfmpcInterface * self;
#line 24 "../src/interface.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XFMPC_TYPE_INTERFACE, XfmpcInterface);
#line 29 "../src/interface.vala"
	_g_object_unref0 (self->priv->button_prev);
#line 30 "../src/interface.vala"
	_g_object_unref0 (self->priv->button_pp);
#line 31 "../src/interface.vala"
	_g_object_unref0 (self->priv->button_next);
#line 32 "../src/interface.vala"
	_g_object_unref0 (self->priv->button_volume);
#line 33 "../src/interface.vala"
	_g_object_unref0 (self->priv->progress_bar);
#line 34 "../src/interface.vala"
	_g_object_unref0 (self->priv->title);
#line 35 "../src/interface.vala"
	_g_object_unref0 (self->priv->subtitle);
#line 24 "../src/interface.vala"
	G_OBJECT_CLASS (xfmpc_interface_parent_class)->finalize (obj);
#line 1533 "interface.c"
}

 G_GNUC_NO_INLINE static GType
xfmpc_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (XfmpcInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xfmpc_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XfmpcInterface), 0, (GInstanceInitFunc) xfmpc_interface_instance_init, NULL };
	GType xfmpc_interface_type_id;
	xfmpc_interface_type_id = g_type_register_static (gtk_box_get_type (), "XfmpcInterface", &g_define_type_info, 0);
	XfmpcInterface_private_offset = g_type_add_instance_private (xfmpc_interface_type_id, sizeof (XfmpcInterfacePrivate));
	return xfmpc_interface_type_id;
}

GType
xfmpc_interface_get_type (void)
{
	static volatile gsize xfmpc_interface_type_id__once = 0;
	if (g_once_init_enter (&xfmpc_interface_type_id__once)) {
		GType xfmpc_interface_type_id;
		xfmpc_interface_type_id = xfmpc_interface_get_type_once ();
		g_once_init_leave (&xfmpc_interface_type_id__once, xfmpc_interface_type_id);
	}
	return xfmpc_interface_type_id__once;
}

