/* playlist.c generated by valac 0.56.18, the Vala compiler
 * generated from playlist.vala, do not modify */

/*
 *  Copyright (c) 2009-2010 Mike Massonnet <mmassonnet@xfce.org>
 *  Copyright (c) 2009-2010 Vincent Legout <vincent@xfce.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "xfmpc.h"
#include <src/libc/mpdclient.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	XFMPC_PLAYLIST_0_PROPERTY,
	XFMPC_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* xfmpc_playlist_properties[XFMPC_PLAYLIST_NUM_PROPERTIES];
typedef enum  {
	XFMPC_PLAYLIST_COLUMNS_COLUMN_ID,
	XFMPC_PLAYLIST_COLUMNS_COLUMN_FILENAME,
	XFMPC_PLAYLIST_COLUMNS_COLUMN_POSITION,
	XFMPC_PLAYLIST_COLUMNS_COLUMN_SONG,
	XFMPC_PLAYLIST_COLUMNS_COLUMN_LENGTH,
	XFMPC_PLAYLIST_COLUMNS_COLUMN_WEIGHT,
	XFMPC_PLAYLIST_COLUMNS_N_COLUMNS
} XfmpcPlaylistColumns;

#define XFMPC_PLAYLIST_TYPE_COLUMNS (xfmpc_playlist_columns_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _XfmpcPlaylistPrivate {
	XfmpcMpdclient* mpdclient;
	XfmpcPreferences* preferences;
	GtkListStore* store;
	GtkTreeModelFilter* filter;
	GtkTreeView* treeview;
	GtkMenu* menu;
	GtkMenuItem* mi_browse;
	GtkMenuItem* mi_information;
	gint current;
	gboolean autocenter;
};

static gint XfmpcPlaylist_private_offset;
static gpointer xfmpc_playlist_parent_class = NULL;
GtkEntry* xfmpc_playlist_filter_entry = NULL;

static GType xfmpc_playlist_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gboolean xfmpc_playlist_visible_func_filter_tree (GtkTreeModel* model,
                                                  GtkTreeIter* iter);
static void xfmpc_playlist_cb_browse_selection (XfmpcPlaylist* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static void xfmpc_playlist_cb_info_selection (XfmpcPlaylist* self);
static gboolean xfmpc_playlist_cb_popup_menu (XfmpcPlaylist* self);
static void xfmpc_playlist_menu_popup (XfmpcPlaylist* self);
static void xfmpc_playlist_cb_pp_changed (XfmpcPlaylist* self,
                                   gboolean is_playing);
static void xfmpc_playlist_cb_song_changed (XfmpcPlaylist* self);
static void xfmpc_playlist_cb_playlist_changed (XfmpcPlaylist* self);
static void xfmpc_playlist_cb_row_activated (XfmpcPlaylist* self,
                                      GtkTreePath* path,
                                      GtkTreeViewColumn* column);
static gboolean xfmpc_playlist_cb_key_released (XfmpcPlaylist* self,
                                         GdkEventKey* event);
static gboolean xfmpc_playlist_cb_button_released (XfmpcPlaylist* self,
                                            GdkEventButton* event);
static void xfmpc_playlist_cb_filter_entry_activated (XfmpcPlaylist* self);
static gboolean xfmpc_playlist_cb_filter_entry_key_released (XfmpcPlaylist* self,
                                                      GdkEventKey* event);
static void xfmpc_playlist_cb_filter_entry_changed (XfmpcPlaylist* self);
static void xfmpc_playlist_cb_filter_entry_icon_activated (XfmpcPlaylist* self,
                                                    GtkEntryIconPosition icon_pos,
                                                    GdkEvent* event);
static GObject * xfmpc_playlist_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _xfmpc_playlist_delete_selection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self);
static void _xfmpc_playlist_cb_browse_selection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                 gpointer self);
static void _xfmpc_playlist_cb_info_selection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self);
static void _xfmpc_playlist_cb_pp_changed_xfmpc_mpdclient_pp_changed (XfmpcMpdclient* _sender,
                                                               gboolean is_playing,
                                                               gpointer self);
static void _xfmpc_playlist_cb_song_changed_xfmpc_mpdclient_song_changed (XfmpcMpdclient* _sender,
                                                                   gpointer self);
static void _xfmpc_playlist_cb_playlist_changed_xfmpc_mpdclient_playlist_changed (XfmpcMpdclient* _sender,
                                                                           gpointer self);
static void _xfmpc_playlist_cb_row_activated_gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                   GtkTreePath* path,
                                                                   GtkTreeViewColumn* column,
                                                                   gpointer self);
static gboolean _xfmpc_playlist_cb_key_released_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                       GdkEventKey* event,
                                                                       gpointer self);
static gboolean _xfmpc_playlist_cb_button_released_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self);
static gboolean _xfmpc_playlist_cb_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender,
                                                              gpointer self);
static void _xfmpc_playlist_cb_filter_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                   gpointer self);
static gboolean _xfmpc_playlist_cb_filter_entry_key_released_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                                    GdkEventKey* event,
                                                                                    gpointer self);
static void _xfmpc_playlist_cb_filter_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                   gpointer self);
static void _xfmpc_playlist_cb_filter_entry_icon_activated_gtk_entry_icon_release (GtkEntry* _sender,
                                                                            GtkEntryIconPosition icon_pos,
                                                                            GdkEvent* event,
                                                                            gpointer self);
static void _xfmpc_playlist_cb_playlist_changed_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void xfmpc_playlist_finalize (GObject * obj);
static GType xfmpc_playlist_get_type_once (void);

static inline gpointer
xfmpc_playlist_get_instance_private (XfmpcPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, XfmpcPlaylist_private_offset);
}

 G_GNUC_NO_INLINE static GType
xfmpc_playlist_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{XFMPC_PLAYLIST_COLUMNS_COLUMN_ID, "XFMPC_PLAYLIST_COLUMNS_COLUMN_ID", "column-id"}, {XFMPC_PLAYLIST_COLUMNS_COLUMN_FILENAME, "XFMPC_PLAYLIST_COLUMNS_COLUMN_FILENAME", "column-filename"}, {XFMPC_PLAYLIST_COLUMNS_COLUMN_POSITION, "XFMPC_PLAYLIST_COLUMNS_COLUMN_POSITION", "column-position"}, {XFMPC_PLAYLIST_COLUMNS_COLUMN_SONG, "XFMPC_PLAYLIST_COLUMNS_COLUMN_SONG", "column-song"}, {XFMPC_PLAYLIST_COLUMNS_COLUMN_LENGTH, "XFMPC_PLAYLIST_COLUMNS_COLUMN_LENGTH", "column-length"}, {XFMPC_PLAYLIST_COLUMNS_COLUMN_WEIGHT, "XFMPC_PLAYLIST_COLUMNS_COLUMN_WEIGHT", "column-weight"}, {XFMPC_PLAYLIST_COLUMNS_N_COLUMNS, "XFMPC_PLAYLIST_COLUMNS_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
	GType xfmpc_playlist_columns_type_id;
	xfmpc_playlist_columns_type_id = g_enum_register_static ("XfmpcPlaylistColumns", values);
	return xfmpc_playlist_columns_type_id;
}

static GType
xfmpc_playlist_columns_get_type (void)
{
	static volatile gsize xfmpc_playlist_columns_type_id__once = 0;
	if (g_once_init_enter (&xfmpc_playlist_columns_type_id__once)) {
		GType xfmpc_playlist_columns_type_id;
		xfmpc_playlist_columns_type_id = xfmpc_playlist_columns_get_type_once ();
		g_once_init_leave (&xfmpc_playlist_columns_type_id__once, xfmpc_playlist_columns_type_id);
	}
	return xfmpc_playlist_columns_type_id__once;
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 205 "playlist.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 213 "playlist.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 219 "playlist.c"
	}
}

static gboolean
xfmpc_playlist_visible_func_filter_tree (GtkTreeModel* model,
                                         GtkTreeIter* iter)
{
	gchar* song = NULL;
	gchar* _tmp0_;
	gchar* search = NULL;
	gchar* _tmp1_;
	gboolean _result_ = FALSE;
	GtkTreeIter _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GtkEntry* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gboolean result;
#line 148 "../src/playlist.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 148 "../src/playlist.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 149 "../src/playlist.vala"
	_tmp0_ = g_strdup ("");
#line 149 "../src/playlist.vala"
	song = _tmp0_;
#line 149 "../src/playlist.vala"
	_tmp1_ = g_strdup ("");
#line 149 "../src/playlist.vala"
	search = _tmp1_;
#line 150 "../src/playlist.vala"
	_result_ = TRUE;
#line 152 "../src/playlist.vala"
	_tmp2_ = *iter;
#line 152 "../src/playlist.vala"
	gtk_tree_model_get (model, &_tmp2_, XFMPC_PLAYLIST_COLUMNS_COLUMN_SONG, &song, -1, -1);
#line 153 "../src/playlist.vala"
	_tmp4_ = song;
#line 153 "../src/playlist.vala"
	if (_tmp4_ == NULL) {
#line 153 "../src/playlist.vala"
		_tmp3_ = TRUE;
#line 266 "playlist.c"
	} else {
		const gchar* _tmp5_;
#line 153 "../src/playlist.vala"
		_tmp5_ = song;
#line 153 "../src/playlist.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "") == 0;
#line 273 "playlist.c"
	}
#line 153 "../src/playlist.vala"
	if (_tmp3_) {
#line 154 "../src/playlist.vala"
		result = TRUE;
#line 154 "../src/playlist.vala"
		_g_free0 (search);
#line 154 "../src/playlist.vala"
		_g_free0 (song);
#line 154 "../src/playlist.vala"
		return result;
#line 285 "playlist.c"
	}
#line 156 "../src/playlist.vala"
	_tmp6_ = xfmpc_playlist_filter_entry;
#line 156 "../src/playlist.vala"
	_tmp7_ = gtk_entry_get_text (_tmp6_);
#line 156 "../src/playlist.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 156 "../src/playlist.vala"
	_g_free0 (search);
#line 156 "../src/playlist.vala"
	search = _tmp8_;
#line 157 "../src/playlist.vala"
	_tmp9_ = search;
#line 157 "../src/playlist.vala"
	_tmp10_ = g_utf8_casefold (_tmp9_, (gssize) -1);
#line 157 "../src/playlist.vala"
	_g_free0 (search);
#line 157 "../src/playlist.vala"
	search = _tmp10_;
#line 159 "../src/playlist.vala"
	_tmp11_ = search;
#line 159 "../src/playlist.vala"
	if (g_strcmp0 (_tmp11_, "") != 0) {
#line 309 "playlist.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 160 "../src/playlist.vala"
		_tmp12_ = song;
#line 160 "../src/playlist.vala"
		_tmp13_ = g_utf8_casefold (_tmp12_, (gssize) -1);
#line 160 "../src/playlist.vala"
		_g_free0 (song);
#line 160 "../src/playlist.vala"
		song = _tmp13_;
#line 162 "../src/playlist.vala"
		_tmp14_ = song;
#line 162 "../src/playlist.vala"
		_tmp15_ = search;
#line 162 "../src/playlist.vala"
		if (string_index_of (_tmp14_, _tmp15_, 0) == -1) {
#line 163 "../src/playlist.vala"
			_result_ = FALSE;
#line 330 "playlist.c"
		}
	}
#line 166 "../src/playlist.vala"
	result = _result_;
#line 166 "../src/playlist.vala"
	_g_free0 (search);
#line 166 "../src/playlist.vala"
	_g_free0 (song);
#line 166 "../src/playlist.vala"
	return result;
#line 341 "playlist.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 180 "../src/playlist.vala"
	return self ? g_object_ref (self) : NULL;
#line 349 "playlist.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 187 "../src/playlist.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 357 "playlist.c"
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
#line 187 "../src/playlist.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
#line 365 "playlist.c"
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
#line 187 "../src/playlist.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
#line 373 "playlist.c"
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 190 "../src/playlist.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 381 "playlist.c"
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 190 "../src/playlist.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 389 "playlist.c"
}

static void
xfmpc_playlist_cb_browse_selection (XfmpcPlaylist* self)
{
	XfmpcDbbrowser* dbbrowser = NULL;
	XfmpcExtendedInterface* extended_interface = NULL;
	gconstpointer _tmp0_;
	gconstpointer _tmp1_;
	GtkTreeSelection* selection = NULL;
	GtkTreeView* _tmp2_;
	GtkTreeSelection* _tmp3_;
	GtkTreeSelection* _tmp4_;
	GtkTreeSelection* _tmp5_;
	GtkTreeModel* model = NULL;
	GtkTreeModelFilter* _tmp6_;
	GtkTreeModel* _tmp7_;
	GList* list = NULL;
	GtkTreeSelection* _tmp8_;
	GtkTreeModel* _tmp9_ = NULL;
	GList* _tmp10_;
	GtkTreeModel* _tmp11_;
	GList* _tmp12_;
	GtkTreeIter iter = {0};
	GtkTreePath* path = NULL;
	GList* _tmp13_;
	gconstpointer _tmp14_;
	GtkTreePath* _tmp15_;
	GtkTreeModelFilter* _tmp16_;
	GtkTreePath* _tmp17_;
	GtkTreeIter _tmp18_ = {0};
	gboolean _tmp19_;
#line 173 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 177 "../src/playlist.vala"
	_tmp0_ = g_object_get_data ((GObject*) self, "XfmpcDbbrowser");
#line 177 "../src/playlist.vala"
	dbbrowser = (XfmpcDbbrowser*) _tmp0_;
#line 178 "../src/playlist.vala"
	_tmp1_ = g_object_get_data ((GObject*) self, "XfmpcExtendedInterface");
#line 178 "../src/playlist.vala"
	extended_interface = (XfmpcExtendedInterface*) _tmp1_;
#line 180 "../src/playlist.vala"
	_tmp2_ = self->priv->treeview;
#line 180 "../src/playlist.vala"
	_tmp3_ = gtk_tree_view_get_selection (_tmp2_);
#line 180 "../src/playlist.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 180 "../src/playlist.vala"
	selection = _tmp4_;
#line 181 "../src/playlist.vala"
	_tmp5_ = selection;
#line 181 "../src/playlist.vala"
	if (gtk_tree_selection_count_selected_rows (_tmp5_) > 1) {
#line 182 "../src/playlist.vala"
		_g_object_unref0 (selection);
#line 182 "../src/playlist.vala"
		return;
#line 448 "playlist.c"
	}
#line 184 "../src/playlist.vala"
	_tmp6_ = self->priv->filter;
#line 184 "../src/playlist.vala"
	_tmp7_ = _g_object_ref0 ((GtkTreeModel*) _tmp6_);
#line 184 "../src/playlist.vala"
	model = _tmp7_;
#line 185 "../src/playlist.vala"
	_tmp8_ = selection;
#line 185 "../src/playlist.vala"
	_tmp10_ = gtk_tree_selection_get_selected_rows (_tmp8_, &_tmp9_);
#line 185 "../src/playlist.vala"
	_g_object_unref0 (model);
#line 185 "../src/playlist.vala"
	_tmp11_ = _g_object_ref0 (_tmp9_);
#line 185 "../src/playlist.vala"
	model = _tmp11_;
#line 185 "../src/playlist.vala"
	list = _tmp10_;
#line 186 "../src/playlist.vala"
	_tmp12_ = list;
#line 186 "../src/playlist.vala"
	if (g_list_length (_tmp12_) == ((guint) 0)) {
#line 187 "../src/playlist.vala"
		(list == NULL) ? NULL : (list = (_g_list_free___vala_GtkTreePath_free0_ (list), NULL));
#line 187 "../src/playlist.vala"
		_g_object_unref0 (model);
#line 187 "../src/playlist.vala"
		_g_object_unref0 (selection);
#line 187 "../src/playlist.vala"
		return;
#line 480 "playlist.c"
	}
#line 190 "../src/playlist.vala"
	_tmp13_ = list;
#line 190 "../src/playlist.vala"
	_tmp14_ = g_list_nth_data (_tmp13_, (guint) 0);
#line 190 "../src/playlist.vala"
	_tmp15_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) _tmp14_);
#line 190 "../src/playlist.vala"
	path = _tmp15_;
#line 191 "../src/playlist.vala"
	_tmp16_ = self->priv->filter;
#line 191 "../src/playlist.vala"
	_tmp17_ = path;
#line 191 "../src/playlist.vala"
	_tmp19_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp16_, &_tmp18_, _tmp17_);
#line 191 "../src/playlist.vala"
	iter = _tmp18_;
#line 191 "../src/playlist.vala"
	if (_tmp19_) {
#line 500 "playlist.c"
		gchar* filename = NULL;
		gchar* _tmp20_;
		gchar* dir = NULL;
		GtkTreeModelFilter* _tmp21_;
		GtkTreeIter _tmp22_;
		gchar* _tmp23_ = NULL;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		XfmpcDbbrowser* _tmp26_;
		const gchar* _tmp27_;
		XfmpcDbbrowser* _tmp28_;
		XfmpcExtendedInterface* _tmp29_;
#line 192 "../src/playlist.vala"
		_tmp20_ = g_strdup ("");
#line 192 "../src/playlist.vala"
		filename = _tmp20_;
#line 193 "../src/playlist.vala"
		_tmp21_ = self->priv->filter;
#line 193 "../src/playlist.vala"
		_tmp22_ = iter;
#line 193 "../src/playlist.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp21_, &_tmp22_, XFMPC_PLAYLIST_COLUMNS_COLUMN_FILENAME, &_tmp23_, -1, -1);
#line 193 "../src/playlist.vala"
		_g_free0 (filename);
#line 193 "../src/playlist.vala"
		filename = _tmp23_;
#line 194 "../src/playlist.vala"
		_tmp24_ = filename;
#line 194 "../src/playlist.vala"
		_tmp25_ = g_path_get_dirname (_tmp24_);
#line 194 "../src/playlist.vala"
		_g_free0 (dir);
#line 194 "../src/playlist.vala"
		dir = _tmp25_;
#line 195 "../src/playlist.vala"
		_tmp26_ = dbbrowser;
#line 195 "../src/playlist.vala"
		_tmp27_ = dir;
#line 195 "../src/playlist.vala"
		xfmpc_dbbrowser_set_wdir (_tmp26_, _tmp27_);
#line 196 "../src/playlist.vala"
		_tmp28_ = dbbrowser;
#line 196 "../src/playlist.vala"
		xfmpc_dbbrowser_reload (_tmp28_);
#line 197 "../src/playlist.vala"
		_tmp29_ = extended_interface;
#line 197 "../src/playlist.vala"
		xfmpc_extended_interface_set_active (_tmp29_, XFMPC_EXTENDED_INTERFACE_EXTENDED_INTERFACE_WIDGET_DBBROWSER);
#line 191 "../src/playlist.vala"
		_g_free0 (dir);
#line 191 "../src/playlist.vala"
		_g_free0 (filename);
#line 553 "playlist.c"
	}
#line 173 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (path);
#line 173 "../src/playlist.vala"
	(list == NULL) ? NULL : (list = (_g_list_free___vala_GtkTreePath_free0_ (list), NULL));
#line 173 "../src/playlist.vala"
	_g_object_unref0 (model);
#line 173 "../src/playlist.vala"
	_g_object_unref0 (selection);
#line 563 "playlist.c"
}

static void
xfmpc_playlist_cb_info_selection (XfmpcPlaylist* self)
{
	GtkTreeIter iter = {0};
	gint id = 0;
	GtkTreeSelection* selection = NULL;
	GtkTreeView* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp2_;
	GtkTreeSelection* _tmp3_;
	GtkTreeModel* model = NULL;
	GtkTreeModelFilter* _tmp4_;
	GtkTreeModel* _tmp5_;
	GList* list = NULL;
	GtkTreeSelection* _tmp6_;
	GtkTreeModel* _tmp7_ = NULL;
	GList* _tmp8_;
	GtkTreeModel* _tmp9_;
	GList* _tmp10_;
	GtkTreePath* path = NULL;
	GList* _tmp11_;
	gconstpointer _tmp12_;
	GtkTreePath* _tmp13_;
	GtkTreeModelFilter* _tmp14_;
	GtkTreePath* _tmp15_;
	GtkTreeIter _tmp16_ = {0};
	gboolean _tmp17_;
#line 201 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/playlist.vala"
	id = 0;
#line 205 "../src/playlist.vala"
	_tmp0_ = self->priv->treeview;
#line 205 "../src/playlist.vala"
	_tmp1_ = gtk_tree_view_get_selection (_tmp0_);
#line 205 "../src/playlist.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 205 "../src/playlist.vala"
	selection = _tmp2_;
#line 206 "../src/playlist.vala"
	_tmp3_ = selection;
#line 206 "../src/playlist.vala"
	if (gtk_tree_selection_count_selected_rows (_tmp3_) > 1) {
#line 207 "../src/playlist.vala"
		_g_object_unref0 (selection);
#line 207 "../src/playlist.vala"
		return;
#line 613 "playlist.c"
	}
#line 209 "../src/playlist.vala"
	_tmp4_ = self->priv->filter;
#line 209 "../src/playlist.vala"
	_tmp5_ = _g_object_ref0 ((GtkTreeModel*) _tmp4_);
#line 209 "../src/playlist.vala"
	model = _tmp5_;
#line 210 "../src/playlist.vala"
	_tmp6_ = selection;
#line 210 "../src/playlist.vala"
	_tmp8_ = gtk_tree_selection_get_selected_rows (_tmp6_, &_tmp7_);
#line 210 "../src/playlist.vala"
	_g_object_unref0 (model);
#line 210 "../src/playlist.vala"
	_tmp9_ = _g_object_ref0 (_tmp7_);
#line 210 "../src/playlist.vala"
	model = _tmp9_;
#line 210 "../src/playlist.vala"
	list = _tmp8_;
#line 211 "../src/playlist.vala"
	_tmp10_ = list;
#line 211 "../src/playlist.vala"
	if (g_list_length (_tmp10_) == ((guint) 0)) {
#line 212 "../src/playlist.vala"
		(list == NULL) ? NULL : (list = (_g_list_free___vala_GtkTreePath_free0_ (list), NULL));
#line 212 "../src/playlist.vala"
		_g_object_unref0 (model);
#line 212 "../src/playlist.vala"
		_g_object_unref0 (selection);
#line 212 "../src/playlist.vala"
		return;
#line 645 "playlist.c"
	}
#line 214 "../src/playlist.vala"
	_tmp11_ = list;
#line 214 "../src/playlist.vala"
	_tmp12_ = g_list_nth_data (_tmp11_, (guint) 0);
#line 214 "../src/playlist.vala"
	_tmp13_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) _tmp12_);
#line 214 "../src/playlist.vala"
	path = _tmp13_;
#line 216 "../src/playlist.vala"
	_tmp14_ = self->priv->filter;
#line 216 "../src/playlist.vala"
	_tmp15_ = path;
#line 216 "../src/playlist.vala"
	_tmp17_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp14_, &_tmp16_, _tmp15_);
#line 216 "../src/playlist.vala"
	iter = _tmp16_;
#line 216 "../src/playlist.vala"
	if (_tmp17_) {
#line 665 "playlist.c"
		GtkTreeModelFilter* _tmp18_;
		GtkTreeIter _tmp19_;
		gint _tmp20_ = 0;
		XfmpcSongDialog* dialog = NULL;
		XfmpcSongDialog* _tmp21_;
		XfmpcSongDialog* _tmp22_;
#line 217 "../src/playlist.vala"
		_tmp18_ = self->priv->filter;
#line 217 "../src/playlist.vala"
		_tmp19_ = iter;
#line 217 "../src/playlist.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp18_, &_tmp19_, XFMPC_PLAYLIST_COLUMNS_COLUMN_ID, &_tmp20_, -1, -1);
#line 217 "../src/playlist.vala"
		id = _tmp20_;
#line 218 "../src/playlist.vala"
		_tmp21_ = xfmpc_song_dialog_new (id);
#line 218 "../src/playlist.vala"
		g_object_ref_sink (_tmp21_);
#line 218 "../src/playlist.vala"
		dialog = _tmp21_;
#line 219 "../src/playlist.vala"
		_tmp22_ = dialog;
#line 219 "../src/playlist.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp22_);
#line 216 "../src/playlist.vala"
		_g_object_unref0 (dialog);
#line 692 "playlist.c"
	}
#line 201 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (path);
#line 201 "../src/playlist.vala"
	(list == NULL) ? NULL : (list = (_g_list_free___vala_GtkTreePath_free0_ (list), NULL));
#line 201 "../src/playlist.vala"
	_g_object_unref0 (model);
#line 201 "../src/playlist.vala"
	_g_object_unref0 (selection);
#line 702 "playlist.c"
}

static gboolean
xfmpc_playlist_cb_popup_menu (XfmpcPlaylist* self)
{
	gboolean result;
#line 223 "../src/playlist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "../src/playlist.vala"
	xfmpc_playlist_menu_popup (self);
#line 225 "../src/playlist.vala"
	result = TRUE;
#line 225 "../src/playlist.vala"
	return result;
#line 717 "playlist.c"
}

static void
xfmpc_playlist_cb_pp_changed (XfmpcPlaylist* self,
                              gboolean is_playing)
{
#line 228 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/playlist.vala"
	xfmpc_playlist_refresh_current_song (self);
#line 728 "playlist.c"
}

static void
xfmpc_playlist_cb_song_changed (XfmpcPlaylist* self)
{
#line 238 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 239 "../src/playlist.vala"
	xfmpc_playlist_refresh_current_song (self);
#line 738 "playlist.c"
}

static void
xfmpc_playlist_cb_playlist_changed (XfmpcPlaylist* self)
{
	gchar* filename = NULL;
	gchar* song = NULL;
	gchar* length = NULL;
	gint id = 0;
	gint pos = 0;
	XfmpcMpdclient* _tmp0_;
	GtkListStore* _tmp1_;
#line 242 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/playlist.vala"
	filename = NULL;
#line 243 "../src/playlist.vala"
	song = NULL;
#line 243 "../src/playlist.vala"
	length = NULL;
#line 244 "../src/playlist.vala"
	id = 0;
#line 244 "../src/playlist.vala"
	pos = 0;
#line 246 "../src/playlist.vala"
	_tmp0_ = self->priv->mpdclient;
#line 246 "../src/playlist.vala"
	self->priv->current = xfmpc_mpdclient_get_id (_tmp0_);
#line 248 "../src/playlist.vala"
	_tmp1_ = self->priv->store;
#line 248 "../src/playlist.vala"
	gtk_list_store_clear (_tmp1_);
#line 250 "../src/playlist.vala"
	while (TRUE) {
#line 773 "playlist.c"
		XfmpcMpdclient* _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gboolean _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 250 "../src/playlist.vala"
		_tmp2_ = self->priv->mpdclient;
#line 250 "../src/playlist.vala"
		_tmp8_ = xfmpc_mpdclient_playlist_read (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 250 "../src/playlist.vala"
		id = _tmp3_;
#line 250 "../src/playlist.vala"
		pos = _tmp4_;
#line 250 "../src/playlist.vala"
		_g_free0 (filename);
#line 250 "../src/playlist.vala"
		filename = _tmp5_;
#line 250 "../src/playlist.vala"
		_g_free0 (song);
#line 250 "../src/playlist.vala"
		song = _tmp6_;
#line 250 "../src/playlist.vala"
		_g_free0 (length);
#line 250 "../src/playlist.vala"
		length = _tmp7_;
#line 250 "../src/playlist.vala"
		if (!_tmp8_) {
#line 250 "../src/playlist.vala"
			break;
#line 808 "playlist.c"
		}
#line 251 "../src/playlist.vala"
		_tmp9_ = filename;
#line 251 "../src/playlist.vala"
		_tmp10_ = song;
#line 251 "../src/playlist.vala"
		_tmp11_ = length;
#line 251 "../src/playlist.vala"
		xfmpc_playlist_append (self, id, pos, _tmp9_, _tmp10_, _tmp11_);
#line 818 "playlist.c"
	}
#line 254 "../src/playlist.vala"
	xfmpc_playlist_refresh_current_song (self);
#line 242 "../src/playlist.vala"
	_g_free0 (length);
#line 242 "../src/playlist.vala"
	_g_free0 (song);
#line 242 "../src/playlist.vala"
	_g_free0 (filename);
#line 828 "playlist.c"
}

static void
xfmpc_playlist_cb_row_activated (XfmpcPlaylist* self,
                                 GtkTreePath* path,
                                 GtkTreeViewColumn* column)
{
	GtkTreeIter iter = {0};
	GtkTreePath* new_path = NULL;
	GtkTreePath* _tmp0_;
	gint id = 0;
	GtkTreeModelFilter* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	gboolean _tmp4_;
	GtkTreeModelFilter* _tmp5_;
	GtkTreeIter _tmp6_;
	gint _tmp7_ = 0;
	GtkEntry* _tmp8_;
	XfmpcMpdclient* _tmp9_;
#line 257 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/playlist.vala"
	g_return_if_fail (path != NULL);
#line 257 "../src/playlist.vala"
	g_return_if_fail (column != NULL);
#line 259 "../src/playlist.vala"
	_tmp0_ = __vala_GtkTreePath_copy0 (path);
#line 259 "../src/playlist.vala"
	new_path = _tmp0_;
#line 260 "../src/playlist.vala"
	id = 0;
#line 262 "../src/playlist.vala"
	_tmp1_ = self->priv->filter;
#line 262 "../src/playlist.vala"
	_tmp2_ = new_path;
#line 262 "../src/playlist.vala"
	_tmp4_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp1_, &_tmp3_, _tmp2_);
#line 262 "../src/playlist.vala"
	iter = _tmp3_;
#line 262 "../src/playlist.vala"
	if (!_tmp4_) {
#line 263 "../src/playlist.vala"
		__vala_GtkTreePath_free0 (new_path);
#line 263 "../src/playlist.vala"
		return;
#line 875 "playlist.c"
	}
#line 265 "../src/playlist.vala"
	_tmp5_ = self->priv->filter;
#line 265 "../src/playlist.vala"
	_tmp6_ = iter;
#line 265 "../src/playlist.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp5_, &_tmp6_, XFMPC_PLAYLIST_COLUMNS_COLUMN_ID, &_tmp7_, -1, -1);
#line 265 "../src/playlist.vala"
	id = _tmp7_;
#line 266 "../src/playlist.vala"
	_tmp8_ = xfmpc_playlist_filter_entry;
#line 266 "../src/playlist.vala"
	gtk_entry_set_text (_tmp8_, "");
#line 267 "../src/playlist.vala"
	_tmp9_ = self->priv->mpdclient;
#line 267 "../src/playlist.vala"
	xfmpc_mpdclient_set_id (_tmp9_, id);
#line 257 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (new_path);
#line 895 "playlist.c"
}

static gboolean
xfmpc_playlist_cb_key_released (XfmpcPlaylist* self,
                                GdkEventKey* event)
{
	gboolean result;
#line 270 "../src/playlist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 270 "../src/playlist.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 271 "../src/playlist.vala"
	if (event->type != GDK_KEY_RELEASE) {
#line 272 "../src/playlist.vala"
		result = FALSE;
#line 272 "../src/playlist.vala"
		return result;
#line 913 "playlist.c"
	}
#line 275 "../src/playlist.vala"
	switch (event->keyval) {
#line 275 "../src/playlist.vala"
		case 0xffff:
#line 919 "playlist.c"
		{
#line 278 "../src/playlist.vala"
			xfmpc_playlist_delete_selection (self);
#line 279 "../src/playlist.vala"
			break;
#line 925 "playlist.c"
		}
		default:
		{
#line 281 "../src/playlist.vala"
			result = FALSE;
#line 281 "../src/playlist.vala"
			return result;
#line 933 "playlist.c"
		}
	}
#line 284 "../src/playlist.vala"
	result = TRUE;
#line 284 "../src/playlist.vala"
	return result;
#line 940 "playlist.c"
}

static gboolean
xfmpc_playlist_cb_button_released (XfmpcPlaylist* self,
                                   GdkEventButton* event)
{
	GtkTreePath* path = NULL;
	GtkTreeSelection* selection = NULL;
	gboolean _tmp0_ = FALSE;
	GtkTreeView* _tmp1_;
	GtkTreeSelection* _tmp2_;
	GtkTreeSelection* _tmp3_;
	gboolean sensitive = FALSE;
	GtkTreeSelection* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkTreeView* _tmp7_;
	GtkTreePath* _tmp8_ = NULL;
	gboolean _tmp9_;
	GtkTreeSelection* _tmp15_;
	gboolean result;
#line 287 "../src/playlist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 287 "../src/playlist.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 291 "../src/playlist.vala"
	if (event->type != GDK_BUTTON_PRESS) {
#line 291 "../src/playlist.vala"
		_tmp0_ = TRUE;
#line 970 "playlist.c"
	} else {
#line 291 "../src/playlist.vala"
		_tmp0_ = event->button != ((guint) 3);
#line 974 "playlist.c"
	}
#line 291 "../src/playlist.vala"
	if (_tmp0_) {
#line 292 "../src/playlist.vala"
		result = FALSE;
#line 292 "../src/playlist.vala"
		_g_object_unref0 (selection);
#line 292 "../src/playlist.vala"
		__vala_GtkTreePath_free0 (path);
#line 292 "../src/playlist.vala"
		return result;
#line 986 "playlist.c"
	}
#line 294 "../src/playlist.vala"
	_tmp1_ = self->priv->treeview;
#line 294 "../src/playlist.vala"
	_tmp2_ = gtk_tree_view_get_selection (_tmp1_);
#line 294 "../src/playlist.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 294 "../src/playlist.vala"
	_g_object_unref0 (selection);
#line 294 "../src/playlist.vala"
	selection = _tmp3_;
#line 296 "../src/playlist.vala"
	_tmp4_ = selection;
#line 296 "../src/playlist.vala"
	sensitive = gtk_tree_selection_count_selected_rows (_tmp4_) == 1;
#line 297 "../src/playlist.vala"
	_tmp5_ = self->priv->mi_browse;
#line 297 "../src/playlist.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, sensitive);
#line 298 "../src/playlist.vala"
	_tmp6_ = self->priv->mi_information;
#line 298 "../src/playlist.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, sensitive);
#line 300 "../src/playlist.vala"
	_tmp7_ = self->priv->treeview;
#line 300 "../src/playlist.vala"
	_tmp9_ = gtk_tree_view_get_path_at_pos (_tmp7_, (gint) event->x, (gint) event->y, &_tmp8_, NULL, NULL, NULL);
#line 300 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (path);
#line 300 "../src/playlist.vala"
	path = _tmp8_;
#line 300 "../src/playlist.vala"
	if (_tmp9_) {
#line 1020 "playlist.c"
		GtkTreeSelection* _tmp10_;
		GtkTreePath* _tmp11_;
#line 303 "../src/playlist.vala"
		_tmp10_ = selection;
#line 303 "../src/playlist.vala"
		_tmp11_ = path;
#line 303 "../src/playlist.vala"
		if (!gtk_tree_selection_path_is_selected (_tmp10_, _tmp11_)) {
#line 1029 "playlist.c"
			GtkTreeSelection* _tmp12_;
			GtkTreeSelection* _tmp13_;
			GtkTreePath* _tmp14_;
#line 304 "../src/playlist.vala"
			_tmp12_ = selection;
#line 304 "../src/playlist.vala"
			gtk_tree_selection_unselect_all (_tmp12_);
#line 305 "../src/playlist.vala"
			_tmp13_ = selection;
#line 305 "../src/playlist.vala"
			_tmp14_ = path;
#line 305 "../src/playlist.vala"
			gtk_tree_selection_select_path (_tmp13_, _tmp14_);
#line 1043 "playlist.c"
		}
	}
#line 309 "../src/playlist.vala"
	_tmp15_ = selection;
#line 309 "../src/playlist.vala"
	if (gtk_tree_selection_count_selected_rows (_tmp15_) < 1) {
#line 310 "../src/playlist.vala"
		result = TRUE;
#line 310 "../src/playlist.vala"
		_g_object_unref0 (selection);
#line 310 "../src/playlist.vala"
		__vala_GtkTreePath_free0 (path);
#line 310 "../src/playlist.vala"
		return result;
#line 1058 "playlist.c"
	}
#line 312 "../src/playlist.vala"
	xfmpc_playlist_menu_popup (self);
#line 314 "../src/playlist.vala"
	result = TRUE;
#line 314 "../src/playlist.vala"
	_g_object_unref0 (selection);
#line 314 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (path);
#line 314 "../src/playlist.vala"
	return result;
#line 1070 "playlist.c"
}

static void
xfmpc_playlist_menu_popup (XfmpcPlaylist* self)
{
	GtkMenu* _tmp0_;
#line 317 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 318 "../src/playlist.vala"
	_tmp0_ = self->priv->menu;
#line 318 "../src/playlist.vala"
	gtk_menu_popup_at_pointer (_tmp0_, NULL);
#line 1083 "playlist.c"
}

static void
xfmpc_playlist_cb_filter_entry_activated (XfmpcPlaylist* self)
{
	GtkTreeModel* model = NULL;
	GtkTreeModelFilter* _tmp0_;
	GtkTreeModel* _tmp1_;
	GList* list = NULL;
	GtkTreeView* _tmp2_;
	GtkTreeSelection* _tmp3_;
	GtkTreeModel* _tmp4_ = NULL;
	GList* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreePath* path = NULL;
	GList* _tmp7_;
	gconstpointer _tmp8_;
	GtkTreePath* _tmp9_;
	GList* _tmp10_;
#line 321 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/playlist.vala"
	_tmp0_ = self->priv->filter;
#line 322 "../src/playlist.vala"
	_tmp1_ = _g_object_ref0 ((GtkTreeModel*) _tmp0_);
#line 322 "../src/playlist.vala"
	model = _tmp1_;
#line 323 "../src/playlist.vala"
	_tmp2_ = self->priv->treeview;
#line 323 "../src/playlist.vala"
	_tmp3_ = gtk_tree_view_get_selection (_tmp2_);
#line 323 "../src/playlist.vala"
	_tmp5_ = gtk_tree_selection_get_selected_rows (_tmp3_, &_tmp4_);
#line 323 "../src/playlist.vala"
	_g_object_unref0 (model);
#line 323 "../src/playlist.vala"
	_tmp6_ = _g_object_ref0 (_tmp4_);
#line 323 "../src/playlist.vala"
	model = _tmp6_;
#line 323 "../src/playlist.vala"
	list = _tmp5_;
#line 324 "../src/playlist.vala"
	_tmp7_ = list;
#line 324 "../src/playlist.vala"
	_tmp8_ = g_list_nth_data (_tmp7_, (guint) 0);
#line 324 "../src/playlist.vala"
	_tmp9_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) _tmp8_);
#line 324 "../src/playlist.vala"
	path = _tmp9_;
#line 326 "../src/playlist.vala"
	_tmp10_ = list;
#line 326 "../src/playlist.vala"
	if (g_list_length (_tmp10_) > ((guint) 0)) {
#line 1137 "playlist.c"
		GtkTreeView* _tmp11_;
		GtkTreePath* _tmp12_;
		GtkTreeView* _tmp13_;
		GtkTreeViewColumn* _tmp14_;
		GtkEntry* _tmp15_;
		GtkTreeView* _tmp16_;
#line 327 "../src/playlist.vala"
		_tmp11_ = self->priv->treeview;
#line 327 "../src/playlist.vala"
		_tmp12_ = path;
#line 327 "../src/playlist.vala"
		_tmp13_ = self->priv->treeview;
#line 327 "../src/playlist.vala"
		_tmp14_ = gtk_tree_view_get_column (_tmp13_, 0);
#line 327 "../src/playlist.vala"
		gtk_tree_view_row_activated (_tmp11_, _tmp12_, _tmp14_);
#line 328 "../src/playlist.vala"
		_tmp15_ = xfmpc_playlist_filter_entry;
#line 328 "../src/playlist.vala"
		gtk_entry_set_text (_tmp15_, "");
#line 329 "../src/playlist.vala"
		xfmpc_playlist_select_row (self, self->priv->current);
#line 330 "../src/playlist.vala"
		_tmp16_ = self->priv->treeview;
#line 330 "../src/playlist.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp16_);
#line 1164 "playlist.c"
	}
#line 321 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (path);
#line 321 "../src/playlist.vala"
	(list == NULL) ? NULL : (list = (_g_list_free___vala_GtkTreePath_free0_ (list), NULL));
#line 321 "../src/playlist.vala"
	_g_object_unref0 (model);
#line 1172 "playlist.c"
}

static gboolean
xfmpc_playlist_cb_filter_entry_key_released (XfmpcPlaylist* self,
                                             GdkEventKey* event)
{
	gboolean result;
#line 334 "../src/playlist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 334 "../src/playlist.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 335 "../src/playlist.vala"
	if (event->type != GDK_KEY_RELEASE) {
#line 336 "../src/playlist.vala"
		result = FALSE;
#line 336 "../src/playlist.vala"
		return result;
#line 1190 "playlist.c"
	}
#line 339 "../src/playlist.vala"
	if (event->keyval == ((guint) 0xff1b)) {
#line 1194 "playlist.c"
		GtkEntry* _tmp0_;
		GtkTreeView* _tmp1_;
#line 340 "../src/playlist.vala"
		_tmp0_ = xfmpc_playlist_filter_entry;
#line 340 "../src/playlist.vala"
		gtk_entry_set_text (_tmp0_, "");
#line 341 "../src/playlist.vala"
		xfmpc_playlist_select_row (self, self->priv->current);
#line 342 "../src/playlist.vala"
		_tmp1_ = self->priv->treeview;
#line 342 "../src/playlist.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp1_);
#line 1207 "playlist.c"
	} else {
		GtkEntry* _tmp2_;
		const gchar* _tmp3_;
#line 345 "../src/playlist.vala"
		_tmp2_ = xfmpc_playlist_filter_entry;
#line 345 "../src/playlist.vala"
		_tmp3_ = gtk_entry_get_text (_tmp2_);
#line 345 "../src/playlist.vala"
		if (g_strcmp0 (_tmp3_, "") != 0) {
#line 346 "../src/playlist.vala"
			xfmpc_playlist_select_row (self, 0);
#line 1219 "playlist.c"
		} else {
#line 348 "../src/playlist.vala"
			xfmpc_playlist_select_row (self, self->priv->current);
#line 1223 "playlist.c"
		}
	}
#line 351 "../src/playlist.vala"
	result = TRUE;
#line 351 "../src/playlist.vala"
	return result;
#line 1230 "playlist.c"
}

static void
xfmpc_playlist_cb_filter_entry_changed (XfmpcPlaylist* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	GtkTreeModelFilter* _tmp4_;
#line 354 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 355 "../src/playlist.vala"
	_tmp0_ = xfmpc_playlist_filter_entry;
#line 355 "../src/playlist.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 355 "../src/playlist.vala"
	if (g_strcmp0 (_tmp1_, "") != 0) {
#line 1247 "playlist.c"
		GtkEntry* _tmp2_;
#line 356 "../src/playlist.vala"
		_tmp2_ = xfmpc_playlist_filter_entry;
#line 356 "../src/playlist.vala"
		gtk_entry_set_icon_from_icon_name (_tmp2_, GTK_ENTRY_ICON_SECONDARY, "edit-clear");
#line 1253 "playlist.c"
	} else {
		GtkEntry* _tmp3_;
#line 359 "../src/playlist.vala"
		_tmp3_ = xfmpc_playlist_filter_entry;
#line 359 "../src/playlist.vala"
		gtk_entry_set_icon_from_icon_name (_tmp3_, GTK_ENTRY_ICON_SECONDARY, NULL);
#line 1260 "playlist.c"
	}
#line 361 "../src/playlist.vala"
	_tmp4_ = self->priv->filter;
#line 361 "../src/playlist.vala"
	gtk_tree_model_filter_refilter (_tmp4_);
#line 1266 "playlist.c"
}

static void
xfmpc_playlist_cb_filter_entry_icon_activated (XfmpcPlaylist* self,
                                               GtkEntryIconPosition icon_pos,
                                               GdkEvent* event)
{
	GtkEntry* _tmp0_;
#line 364 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 364 "../src/playlist.vala"
	g_return_if_fail (event != NULL);
#line 365 "../src/playlist.vala"
	if (icon_pos != GTK_ENTRY_ICON_SECONDARY) {
#line 366 "../src/playlist.vala"
		return;
#line 1283 "playlist.c"
	}
#line 367 "../src/playlist.vala"
	_tmp0_ = xfmpc_playlist_filter_entry;
#line 367 "../src/playlist.vala"
	gtk_entry_set_text (_tmp0_, "");
#line 368 "../src/playlist.vala"
	xfmpc_playlist_select_row (self, self->priv->current);
#line 1291 "playlist.c"
}

void
xfmpc_playlist_append (XfmpcPlaylist* self,
                       gint id,
                       gint pos,
                       const gchar* filename,
                       const gchar* song,
                       const gchar* length)
{
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
#line 375 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/playlist.vala"
	g_return_if_fail (filename != NULL);
#line 375 "../src/playlist.vala"
	g_return_if_fail (song != NULL);
#line 375 "../src/playlist.vala"
	g_return_if_fail (length != NULL);
#line 378 "../src/playlist.vala"
	_tmp0_ = self->priv->store;
#line 378 "../src/playlist.vala"
	gtk_list_store_append (_tmp0_, &_tmp1_);
#line 378 "../src/playlist.vala"
	iter = _tmp1_;
#line 379 "../src/playlist.vala"
	_tmp2_ = self->priv->store;
#line 379 "../src/playlist.vala"
	_tmp3_ = iter;
#line 379 "../src/playlist.vala"
	gtk_list_store_set (_tmp2_, &_tmp3_, XFMPC_PLAYLIST_COLUMNS_COLUMN_ID, id, XFMPC_PLAYLIST_COLUMNS_COLUMN_FILENAME, filename, XFMPC_PLAYLIST_COLUMNS_COLUMN_POSITION, pos + 1, XFMPC_PLAYLIST_COLUMNS_COLUMN_SONG, song, XFMPC_PLAYLIST_COLUMNS_COLUMN_LENGTH, length, XFMPC_PLAYLIST_COLUMNS_COLUMN_WEIGHT, PANGO_WEIGHT_NORMAL, -1, -1);
#line 1327 "playlist.c"
}

void
xfmpc_playlist_refresh_current_song (XfmpcPlaylist* self)
{
	GtkTreeIter iter = {0};
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GtkListStore* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	gboolean _tmp4_;
	XfmpcMpdclient* _tmp7_;
	GtkTreePath* _tmp8_;
	GtkListStore* _tmp9_;
	GtkTreePath* _tmp10_;
	GtkTreeIter _tmp11_ = {0};
	gboolean _tmp12_;
	gboolean _tmp15_ = FALSE;
	GtkEntry* _tmp16_;
	const gchar* _tmp17_;
#line 389 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 393 "../src/playlist.vala"
	if (self->priv->current < 0) {
#line 394 "../src/playlist.vala"
		self->priv->current = 0;
#line 1355 "playlist.c"
	}
#line 396 "../src/playlist.vala"
	_tmp0_ = gtk_tree_path_new_from_indices (self->priv->current, -1, -1);
#line 396 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (path);
#line 396 "../src/playlist.vala"
	path = _tmp0_;
#line 398 "../src/playlist.vala"
	_tmp1_ = self->priv->store;
#line 398 "../src/playlist.vala"
	_tmp2_ = path;
#line 398 "../src/playlist.vala"
	_tmp4_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp1_, &_tmp3_, _tmp2_);
#line 398 "../src/playlist.vala"
	iter = _tmp3_;
#line 398 "../src/playlist.vala"
	if (_tmp4_) {
#line 1373 "playlist.c"
		GtkListStore* _tmp5_;
		GtkTreeIter _tmp6_;
#line 399 "../src/playlist.vala"
		_tmp5_ = self->priv->store;
#line 399 "../src/playlist.vala"
		_tmp6_ = iter;
#line 399 "../src/playlist.vala"
		gtk_list_store_set (_tmp5_, &_tmp6_, XFMPC_PLAYLIST_COLUMNS_COLUMN_WEIGHT, PANGO_WEIGHT_NORMAL, -1, -1);
#line 1382 "playlist.c"
	}
#line 401 "../src/playlist.vala"
	_tmp7_ = self->priv->mpdclient;
#line 401 "../src/playlist.vala"
	self->priv->current = xfmpc_mpdclient_get_pos (_tmp7_);
#line 402 "../src/playlist.vala"
	_tmp8_ = gtk_tree_path_new_from_indices (self->priv->current, -1, -1);
#line 402 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (path);
#line 402 "../src/playlist.vala"
	path = _tmp8_;
#line 403 "../src/playlist.vala"
	_tmp9_ = self->priv->store;
#line 403 "../src/playlist.vala"
	_tmp10_ = path;
#line 403 "../src/playlist.vala"
	_tmp12_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp9_, &_tmp11_, _tmp10_);
#line 403 "../src/playlist.vala"
	iter = _tmp11_;
#line 403 "../src/playlist.vala"
	if (_tmp12_) {
#line 1404 "playlist.c"
		GtkListStore* _tmp13_;
		GtkTreeIter _tmp14_;
#line 404 "../src/playlist.vala"
		_tmp13_ = self->priv->store;
#line 404 "../src/playlist.vala"
		_tmp14_ = iter;
#line 404 "../src/playlist.vala"
		gtk_list_store_set (_tmp13_, &_tmp14_, XFMPC_PLAYLIST_COLUMNS_COLUMN_WEIGHT, PANGO_WEIGHT_BOLD, -1, -1);
#line 1413 "playlist.c"
	}
#line 406 "../src/playlist.vala"
	_tmp16_ = xfmpc_playlist_filter_entry;
#line 406 "../src/playlist.vala"
	_tmp17_ = gtk_entry_get_text (_tmp16_);
#line 406 "../src/playlist.vala"
	if (g_strcmp0 (_tmp17_, "") == 0) {
#line 406 "../src/playlist.vala"
		_tmp15_ = self->priv->autocenter;
#line 1423 "playlist.c"
	} else {
#line 406 "../src/playlist.vala"
		_tmp15_ = FALSE;
#line 1427 "playlist.c"
	}
#line 406 "../src/playlist.vala"
	if (_tmp15_) {
#line 407 "../src/playlist.vala"
		xfmpc_playlist_select_row (self, self->priv->current);
#line 1433 "playlist.c"
	}
#line 389 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (path);
#line 1437 "playlist.c"
}

void
xfmpc_playlist_select_row (XfmpcPlaylist* self,
                           gint i)
{
	GtkTreeModelFilter* _tmp0_;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp1_;
	GtkTreeView* _tmp2_;
	GtkTreePath* _tmp3_;
	GtkTreeView* _tmp4_;
	GtkTreePath* _tmp5_;
#line 410 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 411 "../src/playlist.vala"
	if (self->priv->current < 0) {
#line 412 "../src/playlist.vala"
		return;
#line 1457 "playlist.c"
	}
#line 413 "../src/playlist.vala"
	_tmp0_ = self->priv->filter;
#line 413 "../src/playlist.vala"
	if (gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp0_, NULL) == 0) {
#line 414 "../src/playlist.vala"
		return;
#line 1465 "playlist.c"
	}
#line 416 "../src/playlist.vala"
	_tmp1_ = gtk_tree_path_new_from_indices (i, -1, -1);
#line 416 "../src/playlist.vala"
	path = _tmp1_;
#line 417 "../src/playlist.vala"
	_tmp2_ = self->priv->treeview;
#line 417 "../src/playlist.vala"
	_tmp3_ = path;
#line 417 "../src/playlist.vala"
	gtk_tree_view_set_cursor (_tmp2_, _tmp3_, NULL, FALSE);
#line 418 "../src/playlist.vala"
	_tmp4_ = self->priv->treeview;
#line 418 "../src/playlist.vala"
	_tmp5_ = path;
#line 418 "../src/playlist.vala"
	gtk_tree_view_scroll_to_cell (_tmp4_, _tmp5_, NULL, TRUE, (gfloat) 0.42, (gfloat) 0);
#line 410 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (path);
#line 1485 "playlist.c"
}

void
xfmpc_playlist_delete_selection (XfmpcPlaylist* self)
{
	gint id = 0;
	GtkTreeIter iter = {0};
	GtkTreeModel* model = NULL;
	GtkTreeModelFilter* _tmp0_;
	GtkTreeModel* _tmp1_;
	GList* list = NULL;
	GtkTreeView* _tmp2_;
	GtkTreeSelection* _tmp3_;
	GtkTreeModel* _tmp4_ = NULL;
	GList* _tmp5_;
	GtkTreeModel* _tmp6_;
	GList* _tmp7_;
	XfmpcMpdclient* _tmp17_;
#line 421 "../src/playlist.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/playlist.vala"
	id = 0;
#line 424 "../src/playlist.vala"
	_tmp0_ = self->priv->filter;
#line 424 "../src/playlist.vala"
	_tmp1_ = _g_object_ref0 ((GtkTreeModel*) _tmp0_);
#line 424 "../src/playlist.vala"
	model = _tmp1_;
#line 426 "../src/playlist.vala"
	_tmp2_ = self->priv->treeview;
#line 426 "../src/playlist.vala"
	_tmp3_ = gtk_tree_view_get_selection (_tmp2_);
#line 426 "../src/playlist.vala"
	_tmp5_ = gtk_tree_selection_get_selected_rows (_tmp3_, &_tmp4_);
#line 426 "../src/playlist.vala"
	_g_object_unref0 (model);
#line 426 "../src/playlist.vala"
	_tmp6_ = _g_object_ref0 (_tmp4_);
#line 426 "../src/playlist.vala"
	model = _tmp6_;
#line 426 "../src/playlist.vala"
	list = _tmp5_;
#line 428 "../src/playlist.vala"
	_tmp7_ = list;
#line 1530 "playlist.c"
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
#line 428 "../src/playlist.vala"
		path_collection = _tmp7_;
#line 428 "../src/playlist.vala"
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
#line 1538 "playlist.c"
			GtkTreePath* _tmp8_;
			GtkTreePath* path = NULL;
#line 428 "../src/playlist.vala"
			_tmp8_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) path_it->data);
#line 428 "../src/playlist.vala"
			path = _tmp8_;
#line 1545 "playlist.c"
			{
				GtkTreeModelFilter* _tmp9_;
				GtkTreePath* _tmp10_;
				GtkTreeIter _tmp11_ = {0};
				gboolean _tmp12_;
#line 429 "../src/playlist.vala"
				_tmp9_ = self->priv->filter;
#line 429 "../src/playlist.vala"
				_tmp10_ = path;
#line 429 "../src/playlist.vala"
				_tmp12_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp9_, &_tmp11_, _tmp10_);
#line 429 "../src/playlist.vala"
				iter = _tmp11_;
#line 429 "../src/playlist.vala"
				if (_tmp12_) {
#line 1561 "playlist.c"
					GtkTreeModelFilter* _tmp13_;
					GtkTreeIter _tmp14_;
					gint _tmp15_ = 0;
					XfmpcMpdclient* _tmp16_;
#line 430 "../src/playlist.vala"
					_tmp13_ = self->priv->filter;
#line 430 "../src/playlist.vala"
					_tmp14_ = iter;
#line 430 "../src/playlist.vala"
					gtk_tree_model_get ((GtkTreeModel*) _tmp13_, &_tmp14_, XFMPC_PLAYLIST_COLUMNS_COLUMN_ID, &_tmp15_, -1, -1);
#line 430 "../src/playlist.vala"
					id = _tmp15_;
#line 431 "../src/playlist.vala"
					_tmp16_ = self->priv->mpdclient;
#line 431 "../src/playlist.vala"
					xfmpc_mpdclient_queue_remove_id (_tmp16_, id);
#line 1578 "playlist.c"
				}
#line 428 "../src/playlist.vala"
				__vala_GtkTreePath_free0 (path);
#line 1582 "playlist.c"
			}
		}
	}
#line 435 "../src/playlist.vala"
	_tmp17_ = self->priv->mpdclient;
#line 435 "../src/playlist.vala"
	xfmpc_mpdclient_queue_commit (_tmp17_);
#line 421 "../src/playlist.vala"
	(list == NULL) ? NULL : (list = (_g_list_free___vala_GtkTreePath_free0_ (list), NULL));
#line 421 "../src/playlist.vala"
	_g_object_unref0 (model);
#line 1594 "playlist.c"
}

gboolean
xfmpc_playlist_has_filename (XfmpcPlaylist* self,
                             const gchar* filename,
                             gboolean is_dir)
{
	GtkTreeIter iter = {0};
	GtkTreePath* path = NULL;
	gchar* name = NULL;
	gchar* _tmp0_;
	GtkTreePath* _tmp1_;
	gboolean result;
#line 438 "../src/playlist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 438 "../src/playlist.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 441 "../src/playlist.vala"
	_tmp0_ = g_strdup ("");
#line 441 "../src/playlist.vala"
	name = _tmp0_;
#line 443 "../src/playlist.vala"
	_tmp1_ = gtk_tree_path_new_from_indices (0, -1, -1);
#line 443 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (path);
#line 443 "../src/playlist.vala"
	path = _tmp1_;
#line 444 "../src/playlist.vala"
	while (TRUE) {
#line 1624 "playlist.c"
		GtkListStore* _tmp2_;
		GtkTreePath* _tmp3_;
		GtkTreeIter _tmp4_ = {0};
		gboolean _tmp5_;
		GtkListStore* _tmp6_;
		GtkTreeIter _tmp7_;
		gchar* _tmp8_ = NULL;
		GtkTreePath* _tmp11_;
#line 444 "../src/playlist.vala"
		_tmp2_ = self->priv->store;
#line 444 "../src/playlist.vala"
		_tmp3_ = path;
#line 444 "../src/playlist.vala"
		_tmp5_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp2_, &_tmp4_, _tmp3_);
#line 444 "../src/playlist.vala"
		iter = _tmp4_;
#line 444 "../src/playlist.vala"
		if (!_tmp5_) {
#line 444 "../src/playlist.vala"
			break;
#line 1645 "playlist.c"
		}
#line 445 "../src/playlist.vala"
		_tmp6_ = self->priv->store;
#line 445 "../src/playlist.vala"
		_tmp7_ = iter;
#line 445 "../src/playlist.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp6_, &_tmp7_, XFMPC_PLAYLIST_COLUMNS_COLUMN_FILENAME, &_tmp8_, -1, -1);
#line 445 "../src/playlist.vala"
		_g_free0 (name);
#line 445 "../src/playlist.vala"
		name = _tmp8_;
#line 447 "../src/playlist.vala"
		if (is_dir) {
#line 1659 "playlist.c"
			const gchar* _tmp9_;
#line 448 "../src/playlist.vala"
			_tmp9_ = name;
#line 448 "../src/playlist.vala"
			if (g_str_has_prefix (_tmp9_, filename)) {
#line 449 "../src/playlist.vala"
				result = TRUE;
#line 449 "../src/playlist.vala"
				_g_free0 (name);
#line 449 "../src/playlist.vala"
				__vala_GtkTreePath_free0 (path);
#line 449 "../src/playlist.vala"
				return result;
#line 1673 "playlist.c"
			}
		} else {
			const gchar* _tmp10_;
#line 451 "../src/playlist.vala"
			_tmp10_ = name;
#line 451 "../src/playlist.vala"
			if (g_strcmp0 (_tmp10_, filename) == 0) {
#line 452 "../src/playlist.vala"
				result = TRUE;
#line 452 "../src/playlist.vala"
				_g_free0 (name);
#line 452 "../src/playlist.vala"
				__vala_GtkTreePath_free0 (path);
#line 452 "../src/playlist.vala"
				return result;
#line 1689 "playlist.c"
			}
		}
#line 455 "../src/playlist.vala"
		_tmp11_ = path;
#line 455 "../src/playlist.vala"
		gtk_tree_path_next (_tmp11_);
#line 1696 "playlist.c"
	}
#line 458 "../src/playlist.vala"
	result = FALSE;
#line 458 "../src/playlist.vala"
	_g_free0 (name);
#line 458 "../src/playlist.vala"
	__vala_GtkTreePath_free0 (path);
#line 458 "../src/playlist.vala"
	return result;
#line 1706 "playlist.c"
}

XfmpcPlaylist*
xfmpc_playlist_construct (GType object_type)
{
	XfmpcPlaylist * self = NULL;
#line 24 "../src/playlist.vala"
	self = (XfmpcPlaylist*) g_object_new (object_type, NULL);
#line 24 "../src/playlist.vala"
	return self;
#line 1717 "playlist.c"
}

XfmpcPlaylist*
xfmpc_playlist_new (void)
{
#line 24 "../src/playlist.vala"
	return xfmpc_playlist_construct (XFMPC_TYPE_PLAYLIST);
#line 1725 "playlist.c"
}

static void
_xfmpc_playlist_delete_selection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self)
{
#line 110 "../src/playlist.vala"
	xfmpc_playlist_delete_selection ((XfmpcPlaylist*) self);
#line 1734 "playlist.c"
}

static void
_xfmpc_playlist_cb_browse_selection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self)
{
#line 113 "../src/playlist.vala"
	xfmpc_playlist_cb_browse_selection ((XfmpcPlaylist*) self);
#line 1743 "playlist.c"
}

static void
_xfmpc_playlist_cb_info_selection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self)
{
#line 116 "../src/playlist.vala"
	xfmpc_playlist_cb_info_selection ((XfmpcPlaylist*) self);
#line 1752 "playlist.c"
}

static void
_xfmpc_playlist_cb_pp_changed_xfmpc_mpdclient_pp_changed (XfmpcMpdclient* _sender,
                                                          gboolean is_playing,
                                                          gpointer self)
{
#line 130 "../src/playlist.vala"
	xfmpc_playlist_cb_pp_changed ((XfmpcPlaylist*) self, is_playing);
#line 1762 "playlist.c"
}

static void
_xfmpc_playlist_cb_song_changed_xfmpc_mpdclient_song_changed (XfmpcMpdclient* _sender,
                                                              gpointer self)
{
#line 131 "../src/playlist.vala"
	xfmpc_playlist_cb_song_changed ((XfmpcPlaylist*) self);
#line 1771 "playlist.c"
}

static void
_xfmpc_playlist_cb_playlist_changed_xfmpc_mpdclient_playlist_changed (XfmpcMpdclient* _sender,
                                                                      gpointer self)
{
#line 132 "../src/playlist.vala"
	xfmpc_playlist_cb_playlist_changed ((XfmpcPlaylist*) self);
#line 1780 "playlist.c"
}

static void
_xfmpc_playlist_cb_row_activated_gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                              GtkTreePath* path,
                                                              GtkTreeViewColumn* column,
                                                              gpointer self)
{
#line 134 "../src/playlist.vala"
	xfmpc_playlist_cb_row_activated ((XfmpcPlaylist*) self, path, column);
#line 1791 "playlist.c"
}

static gboolean
_xfmpc_playlist_cb_key_released_gtk_widget_key_release_event (GtkWidget* _sender,
                                                              GdkEventKey* event,
                                                              gpointer self)
{
	gboolean result;
	result = xfmpc_playlist_cb_key_released ((XfmpcPlaylist*) self, event);
#line 135 "../src/playlist.vala"
	return result;
#line 1803 "playlist.c"
}

static gboolean
_xfmpc_playlist_cb_button_released_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                  GdkEventButton* event,
                                                                  gpointer self)
{
	gboolean result;
	result = xfmpc_playlist_cb_button_released ((XfmpcPlaylist*) self, event);
#line 136 "../src/playlist.vala"
	return result;
#line 1815 "playlist.c"
}

static gboolean
_xfmpc_playlist_cb_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender,
                                                     gpointer self)
{
	gboolean result;
	result = xfmpc_playlist_cb_popup_menu ((XfmpcPlaylist*) self);
#line 137 "../src/playlist.vala"
	return result;
#line 1826 "playlist.c"
}

static void
_xfmpc_playlist_cb_filter_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                              gpointer self)
{
#line 139 "../src/playlist.vala"
	xfmpc_playlist_cb_filter_entry_activated ((XfmpcPlaylist*) self);
#line 1835 "playlist.c"
}

static gboolean
_xfmpc_playlist_cb_filter_entry_key_released_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                           GdkEventKey* event,
                                                                           gpointer self)
{
	gboolean result;
	result = xfmpc_playlist_cb_filter_entry_key_released ((XfmpcPlaylist*) self, event);
#line 140 "../src/playlist.vala"
	return result;
#line 1847 "playlist.c"
}

static void
_xfmpc_playlist_cb_filter_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                              gpointer self)
{
#line 141 "../src/playlist.vala"
	xfmpc_playlist_cb_filter_entry_changed ((XfmpcPlaylist*) self);
#line 1856 "playlist.c"
}

static void
_xfmpc_playlist_cb_filter_entry_icon_activated_gtk_entry_icon_release (GtkEntry* _sender,
                                                                       GtkEntryIconPosition icon_pos,
                                                                       GdkEvent* event,
                                                                       gpointer self)
{
#line 142 "../src/playlist.vala"
	xfmpc_playlist_cb_filter_entry_icon_activated ((XfmpcPlaylist*) self, icon_pos, event);
#line 1867 "playlist.c"
}

static void
_xfmpc_playlist_cb_playlist_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 144 "../src/playlist.vala"
	xfmpc_playlist_cb_playlist_changed ((XfmpcPlaylist*) self);
#line 1877 "playlist.c"
}

static GObject *
xfmpc_playlist_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	XfmpcPlaylist * self;
	XfmpcMpdclient* _tmp0_;
	XfmpcPreferences* _tmp1_;
	XfmpcPreferences* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkListStore* _tmp5_;
	GtkListStore* _tmp6_;
	GtkTreeModelFilter* _tmp7_;
	GtkTreeModelFilter* _tmp8_;
	GtkTreeView* _tmp9_;
	GtkTreeView* _tmp10_;
	GtkTreeSelection* _tmp11_;
	GtkTreeView* _tmp12_;
	GtkTreeView* _tmp13_;
	GtkTreeView* _tmp14_;
	GtkTreeView* _tmp15_;
	GtkTreeModelFilter* _tmp16_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp17_;
	GtkCellRendererText* _tmp18_;
	GtkTreeViewColumn* column = NULL;
	GtkCellRendererText* _tmp19_;
	GtkTreeViewColumn* _tmp20_;
	GtkTreeViewColumn* _tmp21_;
	XfmpcPreferences* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	GtkTreeView* _tmp25_;
	GtkTreeViewColumn* _tmp26_;
	GtkCellRendererText* _tmp27_;
	GtkCellRendererText* _tmp28_;
	GtkCellRendererText* _tmp29_;
	GtkTreeViewColumn* _tmp30_;
	GtkTreeViewColumn* _tmp31_;
	GtkTreeView* _tmp32_;
	GtkTreeViewColumn* _tmp33_;
	GtkCellRendererText* _tmp34_;
	GtkCellRendererText* _tmp35_;
	GtkTreeView* _tmp36_;
	GtkCellRendererText* _tmp37_;
	GtkScrolledWindow* scrolled = NULL;
	GtkAdjustment* _tmp38_;
	GtkAdjustment* _tmp39_;
	GtkAdjustment* _tmp40_;
	GtkAdjustment* _tmp41_;
	GtkScrolledWindow* _tmp42_;
	GtkScrolledWindow* _tmp43_;
	GtkScrolledWindow* _tmp44_;
	GtkMenu* _tmp45_;
	GtkMenuItem* mi = NULL;
	GtkMenuItem* _tmp46_;
	GtkMenu* _tmp47_;
	GtkMenuItem* _tmp48_;
	GtkMenuItem* _tmp49_;
	GtkMenuItem* _tmp50_;
	GtkMenu* _tmp51_;
	GtkMenuItem* _tmp52_;
	GtkMenuItem* _tmp53_;
	GtkMenuItem* _tmp54_;
	GtkMenu* _tmp55_;
	GtkMenuItem* _tmp56_;
	GtkMenuItem* _tmp57_;
	GtkMenu* _tmp58_;
	GtkEntry* _tmp59_;
	GtkEntry* _tmp60_;
	GtkEntry* _tmp61_;
	GtkEntry* _tmp62_;
	GtkScrolledWindow* _tmp63_;
	GtkTreeView* _tmp64_;
	GtkScrolledWindow* _tmp65_;
	GtkEntry* _tmp66_;
	XfmpcMpdclient* _tmp67_;
	XfmpcMpdclient* _tmp68_;
	XfmpcMpdclient* _tmp69_;
	GtkTreeView* _tmp70_;
	GtkTreeView* _tmp71_;
	GtkTreeView* _tmp72_;
	GtkTreeView* _tmp73_;
	GtkEntry* _tmp74_;
	GtkEntry* _tmp75_;
	GtkEntry* _tmp76_;
	GtkEntry* _tmp77_;
	XfmpcPreferences* _tmp78_;
	XfmpcPreferences* _tmp79_;
#line 51 "../src/playlist.vala"
	parent_class = G_OBJECT_CLASS (xfmpc_playlist_parent_class);
#line 51 "../src/playlist.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../src/playlist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XFMPC_TYPE_PLAYLIST, XfmpcPlaylist);
#line 52 "../src/playlist.vala"
	_tmp0_ = xfmpc_mpdclient_get_default ();
#line 52 "../src/playlist.vala"
	self->priv->mpdclient = _tmp0_;
#line 53 "../src/playlist.vala"
	_tmp1_ = xfmpc_preferences_get_default ();
#line 53 "../src/playlist.vala"
	self->priv->preferences = _tmp1_;
#line 55 "../src/playlist.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 57 "../src/playlist.vala"
	_tmp2_ = self->priv->preferences;
#line 57 "../src/playlist.vala"
	_tmp3_ = xfmpc_preferences_get_playlist_autocenter (_tmp2_);
#line 57 "../src/playlist.vala"
	_tmp4_ = _tmp3_;
#line 57 "../src/playlist.vala"
	self->priv->autocenter = _tmp4_;
#line 59 "../src/playlist.vala"
	_tmp5_ = gtk_list_store_new ((gint) XFMPC_PLAYLIST_COLUMNS_N_COLUMNS, G_TYPE_INT, G_TYPE_STRING, G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT, -1);
#line 59 "../src/playlist.vala"
	_g_object_unref0 (self->priv->store);
#line 59 "../src/playlist.vala"
	self->priv->store = _tmp5_;
#line 67 "../src/playlist.vala"
	_tmp6_ = self->priv->store;
#line 67 "../src/playlist.vala"
	_tmp7_ = (GtkTreeModelFilter*) gtk_tree_model_filter_new ((GtkTreeModel*) _tmp6_, NULL);
#line 67 "../src/playlist.vala"
	_g_object_unref0 (self->priv->filter);
#line 67 "../src/playlist.vala"
	self->priv->filter = _tmp7_;
#line 68 "../src/playlist.vala"
	_tmp8_ = self->priv->filter;
#line 68 "../src/playlist.vala"
	gtk_tree_model_filter_set_visible_func (_tmp8_, (GtkTreeModelFilterVisibleFunc) xfmpc_playlist_visible_func_filter_tree, NULL, NULL);
#line 70 "../src/playlist.vala"
	_tmp9_ = (GtkTreeView*) gtk_tree_view_new ();
#line 70 "../src/playlist.vala"
	g_object_ref_sink (_tmp9_);
#line 70 "../src/playlist.vala"
	_g_object_unref0 (self->priv->treeview);
#line 70 "../src/playlist.vala"
	self->priv->treeview = _tmp9_;
#line 71 "../src/playlist.vala"
	_tmp10_ = self->priv->treeview;
#line 71 "../src/playlist.vala"
	_tmp11_ = gtk_tree_view_get_selection (_tmp10_);
#line 71 "../src/playlist.vala"
	gtk_tree_selection_set_mode (_tmp11_, GTK_SELECTION_MULTIPLE);
#line 72 "../src/playlist.vala"
	_tmp12_ = self->priv->treeview;
#line 72 "../src/playlist.vala"
	gtk_tree_view_set_rubber_banding (_tmp12_, TRUE);
#line 73 "../src/playlist.vala"
	_tmp13_ = self->priv->treeview;
#line 73 "../src/playlist.vala"
	gtk_tree_view_set_enable_search (_tmp13_, FALSE);
#line 74 "../src/playlist.vala"
	_tmp14_ = self->priv->treeview;
#line 74 "../src/playlist.vala"
	gtk_tree_view_set_headers_visible (_tmp14_, FALSE);
#line 75 "../src/playlist.vala"
	_tmp15_ = self->priv->treeview;
#line 75 "../src/playlist.vala"
	_tmp16_ = self->priv->filter;
#line 75 "../src/playlist.vala"
	gtk_tree_view_set_model (_tmp15_, (GtkTreeModel*) _tmp16_);
#line 77 "../src/playlist.vala"
	_tmp17_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 77 "../src/playlist.vala"
	g_object_ref_sink (_tmp17_);
#line 77 "../src/playlist.vala"
	cell = _tmp17_;
#line 78 "../src/playlist.vala"
	_tmp18_ = cell;
#line 78 "../src/playlist.vala"
	g_object_set ((GtkCellRenderer*) _tmp18_, "xalign", (gfloat) 1, NULL);
#line 79 "../src/playlist.vala"
	_tmp19_ = cell;
#line 79 "../src/playlist.vala"
	_tmp20_ = gtk_tree_view_column_new_with_attributes ("Position", (GtkCellRenderer*) _tmp19_, "text", XFMPC_PLAYLIST_COLUMNS_COLUMN_POSITION, "weight", XFMPC_PLAYLIST_COLUMNS_COLUMN_WEIGHT, NULL, NULL);
#line 79 "../src/playlist.vala"
	g_object_ref_sink (_tmp20_);
#line 79 "../src/playlist.vala"
	column = _tmp20_;
#line 83 "../src/playlist.vala"
	_tmp21_ = column;
#line 83 "../src/playlist.vala"
	_tmp22_ = self->priv->preferences;
#line 83 "../src/playlist.vala"
	_tmp23_ = xfmpc_preferences_get_playlist_show_position (_tmp22_);
#line 83 "../src/playlist.vala"
	_tmp24_ = _tmp23_;
#line 83 "../src/playlist.vala"
	gtk_tree_view_column_set_visible (_tmp21_, _tmp24_);
#line 84 "../src/playlist.vala"
	_tmp25_ = self->priv->treeview;
#line 84 "../src/playlist.vala"
	_tmp26_ = column;
#line 84 "../src/playlist.vala"
	gtk_tree_view_append_column (_tmp25_, _tmp26_);
#line 86 "../src/playlist.vala"
	_tmp27_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 86 "../src/playlist.vala"
	g_object_ref_sink (_tmp27_);
#line 86 "../src/playlist.vala"
	_g_object_unref0 (cell);
#line 86 "../src/playlist.vala"
	cell = _tmp27_;
#line 87 "../src/playlist.vala"
	_tmp28_ = cell;
#line 87 "../src/playlist.vala"
	g_object_set (_tmp28_, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 88 "../src/playlist.vala"
	_tmp29_ = cell;
#line 88 "../src/playlist.vala"
	_tmp30_ = gtk_tree_view_column_new_with_attributes ("Song", (GtkCellRenderer*) _tmp29_, "text", XFMPC_PLAYLIST_COLUMNS_COLUMN_SONG, "weight", XFMPC_PLAYLIST_COLUMNS_COLUMN_WEIGHT, NULL, NULL);
#line 88 "../src/playlist.vala"
	g_object_ref_sink (_tmp30_);
#line 88 "../src/playlist.vala"
	_g_object_unref0 (column);
#line 88 "../src/playlist.vala"
	column = _tmp30_;
#line 92 "../src/playlist.vala"
	_tmp31_ = column;
#line 92 "../src/playlist.vala"
	gtk_tree_view_column_set_expand (_tmp31_, TRUE);
#line 93 "../src/playlist.vala"
	_tmp32_ = self->priv->treeview;
#line 93 "../src/playlist.vala"
	_tmp33_ = column;
#line 93 "../src/playlist.vala"
	gtk_tree_view_append_column (_tmp32_, _tmp33_);
#line 95 "../src/playlist.vala"
	_tmp34_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 95 "../src/playlist.vala"
	g_object_ref_sink (_tmp34_);
#line 95 "../src/playlist.vala"
	_g_object_unref0 (cell);
#line 95 "../src/playlist.vala"
	cell = _tmp34_;
#line 96 "../src/playlist.vala"
	_tmp35_ = cell;
#line 96 "../src/playlist.vala"
	g_object_set ((GtkCellRenderer*) _tmp35_, "xalign", (gfloat) 1, NULL);
#line 97 "../src/playlist.vala"
	_tmp36_ = self->priv->treeview;
#line 97 "../src/playlist.vala"
	_tmp37_ = cell;
#line 97 "../src/playlist.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp36_, -1, "Length", (GtkCellRenderer*) _tmp37_, "text", XFMPC_PLAYLIST_COLUMNS_COLUMN_LENGTH, "weight", XFMPC_PLAYLIST_COLUMNS_COLUMN_WEIGHT, NULL, NULL);
#line 102 "../src/playlist.vala"
	_tmp38_ = gtk_adjustment_new ((gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 102 "../src/playlist.vala"
	g_object_ref_sink (_tmp38_);
#line 102 "../src/playlist.vala"
	_tmp39_ = _tmp38_;
#line 102 "../src/playlist.vala"
	_tmp40_ = gtk_adjustment_new ((gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 102 "../src/playlist.vala"
	g_object_ref_sink (_tmp40_);
#line 102 "../src/playlist.vala"
	_tmp41_ = _tmp40_;
#line 102 "../src/playlist.vala"
	_tmp42_ = (GtkScrolledWindow*) gtk_scrolled_window_new (_tmp39_, _tmp41_);
#line 102 "../src/playlist.vala"
	g_object_ref_sink (_tmp42_);
#line 102 "../src/playlist.vala"
	_tmp43_ = _tmp42_;
#line 102 "../src/playlist.vala"
	_g_object_unref0 (_tmp41_);
#line 102 "../src/playlist.vala"
	_g_object_unref0 (_tmp39_);
#line 102 "../src/playlist.vala"
	scrolled = _tmp43_;
#line 104 "../src/playlist.vala"
	_tmp44_ = scrolled;
#line 104 "../src/playlist.vala"
	gtk_scrolled_window_set_policy (_tmp44_, GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
#line 106 "../src/playlist.vala"
	_tmp45_ = (GtkMenu*) gtk_menu_new ();
#line 106 "../src/playlist.vala"
	g_object_ref_sink (_tmp45_);
#line 106 "../src/playlist.vala"
	_g_object_unref0 (self->priv->menu);
#line 106 "../src/playlist.vala"
	self->priv->menu = _tmp45_;
#line 108 "../src/playlist.vala"
	_tmp46_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Remove"));
#line 108 "../src/playlist.vala"
	g_object_ref_sink (_tmp46_);
#line 108 "../src/playlist.vala"
	mi = _tmp46_;
#line 109 "../src/playlist.vala"
	_tmp47_ = self->priv->menu;
#line 109 "../src/playlist.vala"
	_tmp48_ = mi;
#line 109 "../src/playlist.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp47_, _tmp48_);
#line 110 "../src/playlist.vala"
	_tmp49_ = mi;
#line 110 "../src/playlist.vala"
	g_signal_connect_object (_tmp49_, "activate", (GCallback) _xfmpc_playlist_delete_selection_gtk_menu_item_activate, self, 0);
#line 111 "../src/playlist.vala"
	_tmp50_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Browse"));
#line 111 "../src/playlist.vala"
	g_object_ref_sink (_tmp50_);
#line 111 "../src/playlist.vala"
	_g_object_unref0 (self->priv->mi_browse);
#line 111 "../src/playlist.vala"
	self->priv->mi_browse = _tmp50_;
#line 112 "../src/playlist.vala"
	_tmp51_ = self->priv->menu;
#line 112 "../src/playlist.vala"
	_tmp52_ = self->priv->mi_browse;
#line 112 "../src/playlist.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp51_, _tmp52_);
#line 113 "../src/playlist.vala"
	_tmp53_ = self->priv->mi_browse;
#line 113 "../src/playlist.vala"
	g_signal_connect_object (_tmp53_, "activate", (GCallback) _xfmpc_playlist_cb_browse_selection_gtk_menu_item_activate, self, 0);
#line 114 "../src/playlist.vala"
	_tmp54_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Info"));
#line 114 "../src/playlist.vala"
	g_object_ref_sink (_tmp54_);
#line 114 "../src/playlist.vala"
	_g_object_unref0 (self->priv->mi_information);
#line 114 "../src/playlist.vala"
	self->priv->mi_information = _tmp54_;
#line 115 "../src/playlist.vala"
	_tmp55_ = self->priv->menu;
#line 115 "../src/playlist.vala"
	_tmp56_ = self->priv->mi_information;
#line 115 "../src/playlist.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp55_, _tmp56_);
#line 116 "../src/playlist.vala"
	_tmp57_ = self->priv->mi_information;
#line 116 "../src/playlist.vala"
	g_signal_connect_object (_tmp57_, "activate", (GCallback) _xfmpc_playlist_cb_info_selection_gtk_menu_item_activate, self, 0);
#line 118 "../src/playlist.vala"
	_tmp58_ = self->priv->menu;
#line 118 "../src/playlist.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp58_);
#line 120 "../src/playlist.vala"
	_tmp59_ = (GtkEntry*) gtk_entry_new ();
#line 120 "../src/playlist.vala"
	g_object_ref_sink (_tmp59_);
#line 120 "../src/playlist.vala"
	_g_object_unref0 (xfmpc_playlist_filter_entry);
#line 120 "../src/playlist.vala"
	xfmpc_playlist_filter_entry = _tmp59_;
#line 121 "../src/playlist.vala"
	_tmp60_ = xfmpc_playlist_filter_entry;
#line 121 "../src/playlist.vala"
	gtk_entry_set_icon_from_icon_name (_tmp60_, GTK_ENTRY_ICON_PRIMARY, "edit-find");
#line 122 "../src/playlist.vala"
	_tmp61_ = xfmpc_playlist_filter_entry;
#line 122 "../src/playlist.vala"
	gtk_entry_set_icon_activatable (_tmp61_, GTK_ENTRY_ICON_PRIMARY, FALSE);
#line 123 "../src/playlist.vala"
	_tmp62_ = xfmpc_playlist_filter_entry;
#line 123 "../src/playlist.vala"
	gtk_entry_set_icon_activatable (_tmp62_, GTK_ENTRY_ICON_SECONDARY, TRUE);
#line 125 "../src/playlist.vala"
	_tmp63_ = scrolled;
#line 125 "../src/playlist.vala"
	_tmp64_ = self->priv->treeview;
#line 125 "../src/playlist.vala"
	gtk_container_add ((GtkContainer*) _tmp63_, (GtkWidget*) _tmp64_);
#line 126 "../src/playlist.vala"
	_tmp65_ = scrolled;
#line 126 "../src/playlist.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp65_, TRUE, TRUE, (guint) 0);
#line 127 "../src/playlist.vala"
	_tmp66_ = xfmpc_playlist_filter_entry;
#line 127 "../src/playlist.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp66_, FALSE, FALSE, (guint) 0);
#line 130 "../src/playlist.vala"
	_tmp67_ = self->priv->mpdclient;
#line 130 "../src/playlist.vala"
	g_signal_connect_object (_tmp67_, "pp-changed", (GCallback) _xfmpc_playlist_cb_pp_changed_xfmpc_mpdclient_pp_changed, self, 0);
#line 131 "../src/playlist.vala"
	_tmp68_ = self->priv->mpdclient;
#line 131 "../src/playlist.vala"
	g_signal_connect_object (_tmp68_, "song-changed", (GCallback) _xfmpc_playlist_cb_song_changed_xfmpc_mpdclient_song_changed, self, 0);
#line 132 "../src/playlist.vala"
	_tmp69_ = self->priv->mpdclient;
#line 132 "../src/playlist.vala"
	g_signal_connect_object (_tmp69_, "playlist-changed", (GCallback) _xfmpc_playlist_cb_playlist_changed_xfmpc_mpdclient_playlist_changed, self, 0);
#line 134 "../src/playlist.vala"
	_tmp70_ = self->priv->treeview;
#line 134 "../src/playlist.vala"
	g_signal_connect_object (_tmp70_, "row-activated", (GCallback) _xfmpc_playlist_cb_row_activated_gtk_tree_view_row_activated, self, 0);
#line 135 "../src/playlist.vala"
	_tmp71_ = self->priv->treeview;
#line 135 "../src/playlist.vala"
	g_signal_connect_object ((GtkWidget*) _tmp71_, "key-release-event", (GCallback) _xfmpc_playlist_cb_key_released_gtk_widget_key_release_event, self, 0);
#line 136 "../src/playlist.vala"
	_tmp72_ = self->priv->treeview;
#line 136 "../src/playlist.vala"
	g_signal_connect_object ((GtkWidget*) _tmp72_, "button-press-event", (GCallback) _xfmpc_playlist_cb_button_released_gtk_widget_button_press_event, self, 0);
#line 137 "../src/playlist.vala"
	_tmp73_ = self->priv->treeview;
#line 137 "../src/playlist.vala"
	g_signal_connect_object ((GtkWidget*) _tmp73_, "popup-menu", (GCallback) _xfmpc_playlist_cb_popup_menu_gtk_widget_popup_menu, self, 0);
#line 139 "../src/playlist.vala"
	_tmp74_ = xfmpc_playlist_filter_entry;
#line 139 "../src/playlist.vala"
	g_signal_connect_object (_tmp74_, "activate", (GCallback) _xfmpc_playlist_cb_filter_entry_activated_gtk_entry_activate, self, 0);
#line 140 "../src/playlist.vala"
	_tmp75_ = xfmpc_playlist_filter_entry;
#line 140 "../src/playlist.vala"
	g_signal_connect_object ((GtkWidget*) _tmp75_, "key-release-event", (GCallback) _xfmpc_playlist_cb_filter_entry_key_released_gtk_widget_key_release_event, self, 0);
#line 141 "../src/playlist.vala"
	_tmp76_ = xfmpc_playlist_filter_entry;
#line 141 "../src/playlist.vala"
	g_signal_connect_object ((GtkEditable*) _tmp76_, "changed", (GCallback) _xfmpc_playlist_cb_filter_entry_changed_gtk_editable_changed, self, 0);
#line 142 "../src/playlist.vala"
	_tmp77_ = xfmpc_playlist_filter_entry;
#line 142 "../src/playlist.vala"
	g_signal_connect_object (_tmp77_, "icon-release", (GCallback) _xfmpc_playlist_cb_filter_entry_icon_activated_gtk_entry_icon_release, self, 0);
#line 144 "../src/playlist.vala"
	_tmp78_ = self->priv->preferences;
#line 144 "../src/playlist.vala"
	g_signal_connect_object ((GObject*) _tmp78_, "notify::song-format", (GCallback) _xfmpc_playlist_cb_playlist_changed_g_object_notify, self, 0);
#line 145 "../src/playlist.vala"
	_tmp79_ = self->priv->preferences;
#line 145 "../src/playlist.vala"
	g_signal_connect_object ((GObject*) _tmp79_, "notify::song-format-custom", (GCallback) _xfmpc_playlist_cb_playlist_changed_g_object_notify, self, 0);
#line 51 "../src/playlist.vala"
	_g_object_unref0 (mi);
#line 51 "../src/playlist.vala"
	_g_object_unref0 (scrolled);
#line 51 "../src/playlist.vala"
	_g_object_unref0 (column);
#line 51 "../src/playlist.vala"
	_g_object_unref0 (cell);
#line 51 "../src/playlist.vala"
	return obj;
#line 2318 "playlist.c"
}

static void
xfmpc_playlist_class_init (XfmpcPlaylistClass * klass,
                           gpointer klass_data)
{
#line 24 "../src/playlist.vala"
	xfmpc_playlist_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/playlist.vala"
	g_type_class_adjust_private_offset (klass, &XfmpcPlaylist_private_offset);
#line 24 "../src/playlist.vala"
	G_OBJECT_CLASS (klass)->constructor = xfmpc_playlist_constructor;
#line 24 "../src/playlist.vala"
	G_OBJECT_CLASS (klass)->finalize = xfmpc_playlist_finalize;
#line 2333 "playlist.c"
}

static void
xfmpc_playlist_instance_init (XfmpcPlaylist * self,
                              gpointer klass)
{
#line 24 "../src/playlist.vala"
	self->priv = xfmpc_playlist_get_instance_private (self);
#line 38 "../src/playlist.vala"
	self->priv->current = 0;
#line 2344 "playlist.c"
}

static void
xfmpc_playlist_finalize (GObject * obj)
{
	XfmpcPlaylist * self;
#line 24 "../src/playlist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XFMPC_TYPE_PLAYLIST, XfmpcPlaylist);
#line 29 "../src/playlist.vala"
	_g_object_unref0 (self->priv->store);
#line 30 "../src/playlist.vala"
	_g_object_unref0 (self->priv->filter);
#line 31 "../src/playlist.vala"
	_g_object_unref0 (self->priv->treeview);
#line 32 "../src/playlist.vala"
	_g_object_unref0 (self->priv->menu);
#line 35 "../src/playlist.vala"
	_g_object_unref0 (self->priv->mi_browse);
#line 36 "../src/playlist.vala"
	_g_object_unref0 (self->priv->mi_information);
#line 24 "../src/playlist.vala"
	G_OBJECT_CLASS (xfmpc_playlist_parent_class)->finalize (obj);
#line 2367 "playlist.c"
}

 G_GNUC_NO_INLINE static GType
xfmpc_playlist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (XfmpcPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xfmpc_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XfmpcPlaylist), 0, (GInstanceInitFunc) xfmpc_playlist_instance_init, NULL };
	GType xfmpc_playlist_type_id;
	xfmpc_playlist_type_id = g_type_register_static (gtk_box_get_type (), "XfmpcPlaylist", &g_define_type_info, 0);
	XfmpcPlaylist_private_offset = g_type_add_instance_private (xfmpc_playlist_type_id, sizeof (XfmpcPlaylistPrivate));
	return xfmpc_playlist_type_id;
}

GType
xfmpc_playlist_get_type (void)
{
	static volatile gsize xfmpc_playlist_type_id__once = 0;
	if (g_once_init_enter (&xfmpc_playlist_type_id__once)) {
		GType xfmpc_playlist_type_id;
		xfmpc_playlist_type_id = xfmpc_playlist_get_type_once ();
		g_once_init_leave (&xfmpc_playlist_type_id__once, xfmpc_playlist_type_id);
	}
	return xfmpc_playlist_type_id__once;
}

